<div xmlns="http://www.w3.org/1999/xhtml" xmlns:html="http://www.w3.org/1999/xhtml" xmlns:pm="http://www.polymake.org/ns/docs#3" id="content"><h1>application: topaz</h1><div class="descr"><p> The <em class="u">TOP</em>ology <em class="u">A</em>pplication <em class="u">Z</em>oo deals with abstract simplicial complexes.
 A complex is given as a list of facets.  You can ask for its global properties (<a href="#topaz__MANIFOLD__207" onclick="unfold('span:topaz__MANIFOLD__207');">manifold recognition</a>,
 <a href="#topaz__HOMOLOGY__197" onclick="unfold('span:topaz__HOMOLOGY__197');">homology groups</a>, etc.),  explore the local vertex environment (<a href="#topaz__star__99" onclick="unfold('span:topaz__star__99');">stars</a>, <a href="#topaz__link_complex__91" onclick="unfold('span:topaz__link_complex__91');">links</a>, etc.),  and make a lot
 of constructions.</p><p> The visualization means are constrained, as they are mostly based on the <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a> (1-skeleton) of a complex.</p></div><b>imports from: </b><a href="common.html">common</a>, <a href="graph.html">graph</a><br/><b>uses: </b><a href="group.html">group</a>, <a href="ideal.html">ideal</a><br/><div class="level2"><h2><b>Objects</b></h2><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__GeometricSimplicialComplex__6" onclick="swap_content('span:topaz__GeometricSimplicialComplex__6'); return false;">
		 	
	</div><div class="unfoldable"><div class="object"><h3><a href="#" class="javalink" id="topaz__GeometricSimplicialComplex__6" onclick="swap_content('span:topaz__GeometricSimplicialComplex__6'); return false;"><span class="object">GeometricSimplicialComplex</span></a></h3></div><div style="display: inline" id="span:topaz__GeometricSimplicialComplex__6" class="foldit"><div class="descr"><p> A geometric simplicial complex, i.e., a simplicial complex with a geometric realization.
 <em class="param">Scalar</em> is the numeric data type used for the coordinates.</p></div><b>derived from: </b><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a><br/><div class="level3"><h5>Type Parameters</h5><table class="args"><tr><td class="param">Scalar</td><td><div class="descr"><div>default: <a href="common.html#common__Rational__328" onclick="unfold('span:common__Rational__328');">Rational</a></div></div></td></tr></table></div><h4>Properties of GeometricSimplicialComplex</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__COORDINATES__117" onclick="swap_content('span:topaz__COORDINATES__117'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__COORDINATES__117" onclick="swap_content('span:topaz__COORDINATES__117'); return false;"><b>COORDINATES</b>:
		</a><a href="common.html#common__Matrix__300" onclick="unfold('span:common__Matrix__300');">common::Matrix</a><br/><div style="display: inline" id="span:topaz__COORDINATES__117" class="foldit"><div class="descr"><p> Coordinates for the vertices of the simplicial complex, such that the complex is
 embedded without crossings in some R<sup>e</sup>.  Vector (x<sub>1</sub>, .... x<sub>e</sub>) represents a point
 in Euclidean e-space.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__G_DIM__118" onclick="swap_content('span:topaz__G_DIM__118'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__G_DIM__118" onclick="swap_content('span:topaz__G_DIM__118'); return false;"><b>G_DIM</b>:
		</a><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">common::Int</a><br/><div style="display: inline" id="span:topaz__G_DIM__118" class="foldit"><div class="descr"><p> Dimension e of the space in which the <a href="#topaz__COORDINATES__117" onclick="unfold('span:topaz__COORDINATES__117');">COORDINATES</a> of the complex is embedded.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__N_UNIMODULAR__115" onclick="swap_content('span:topaz__N_UNIMODULAR__115'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__N_UNIMODULAR__115" onclick="swap_content('span:topaz__N_UNIMODULAR__115'); return false;"><b>N_UNIMODULAR</b>:
		</a><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">common::Int</a><br/><div style="display: inline" id="span:topaz__N_UNIMODULAR__115" class="foldit"><div class="descr"><p> count how many simplcies of a geometric simplicial complex are unimodular.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__SIGNATURE__119" onclick="swap_content('span:topaz__SIGNATURE__119'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__SIGNATURE__119" onclick="swap_content('span:topaz__SIGNATURE__119'); return false;"><b>SIGNATURE</b>:
		</a><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">common::Int</a><br/><div style="display: inline" id="span:topaz__SIGNATURE__119" class="foldit"><div class="descr"><p> Signature of a geometric simplicial complex embedded in the integer lattice.
 Like <a href="#topaz__DUAL_GRAPH_SIGNATURE__223" onclick="unfold('span:topaz__DUAL_GRAPH_SIGNATURE__223');">DUAL_GRAPH_SIGNATURE</a>, but only simplices with odd normalized volume are counted.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__UNIMODULAR__114" onclick="swap_content('span:topaz__UNIMODULAR__114'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__UNIMODULAR__114" onclick="swap_content('span:topaz__UNIMODULAR__114'); return false;"><b>UNIMODULAR</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__UNIMODULAR__114" class="foldit"><div class="descr"><p> A geometric simplicial complex is unimodular if all simplices have unit normalized volume.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__VOLUME__116" onclick="swap_content('span:topaz__VOLUME__116'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VOLUME__116" onclick="swap_content('span:topaz__VOLUME__116'); return false;"><b>VOLUME</b>:
		</a><a href="#" onclick="unfold('span:');">GeometricSimplicialComplex::Scalar</a><br/><div style="display: inline" id="span:topaz__VOLUME__116" class="foldit"><div class="descr"><p> Volume of a geometric simplicial complex.</p></div></div></div></div></li></ul><h4>User Methods of GeometricSimplicialComplex</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__VISUAL__120" onclick="swap_content('span:topaz__VISUAL__120'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VISUAL__120" onclick="swap_content('span:topaz__VISUAL__120'); return false;"><b>VISUAL</b></a>
			()  

			<div style="display: inline" id="span:topaz__VISUAL__120" class="foldit"><br/><div class="descr_func"><div class="descr"><p> TODO: consider all inherited user methods; then: user_method ... : COORDINATES ... </p></div></div><div class="level3"><h5>Options</h5><table class="args"><tr><td>option list:</td><td><a href="common.html#common__Visual__Polygon__decorations__341" onclick="unfold('span:common__Visual__Polygon__decorations__341');">Visual::Polygon::decorations</a></td></tr><tr><td>option list:</td><td><a href="graph.html#graph__Visual__Graph__decorations__74" onclick="unfold('span:graph__Visual__Graph__decorations__74');">Visual::Graph::decorations</a></td></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__HyperbolicSurface__11" onclick="swap_content('span:topaz__HyperbolicSurface__11'); return false;">
		 	
	</div><div class="unfoldable"><div class="object"><h3><a href="#" class="javalink" id="topaz__HyperbolicSurface__11" onclick="swap_content('span:topaz__HyperbolicSurface__11'); return false;"><span class="object">HyperbolicSurface</span></a></h3></div><div style="display: inline" id="span:topaz__HyperbolicSurface__11" class="foldit"><div class="descr"><p>A hyperbolic surface (noncompact, finite area) is given by a triangulation <a href="#topaz__DCEL_DATA__143" onclick="unfold('span:topaz__DCEL_DATA__143');">DCEL_DATA</a> (the topological data) and <a href="#topaz__PENNER_COORDINATES__140" onclick="unfold('span:topaz__PENNER_COORDINATES__140');">PENNER_COORDINATES</a> (the metric data).</p></div><div class="level3"/><h4>Properties of HyperbolicSurface</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__DCEL_DATA__143" onclick="swap_content('span:topaz__DCEL_DATA__143'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__DCEL_DATA__143" onclick="swap_content('span:topaz__DCEL_DATA__143'); return false;"><b>DCEL_DATA</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Array&lt;Int&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__DCEL_DATA__143" class="foldit"><div class="descr"><p> The triangulation of the surface is encoded by a half edge data structure.
 For each edge i of the triangulation there are two half edges 2i and 2i+1, one for each orientation.
 Each row reads as follows: [ 2i.head , (2i+1).head , 2i.next , (2i+1).next]</p></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">A triangulated sphere with three punctures can be given by the following <a href="#topaz__DCEL_DATA__143" onclick="unfold('span:topaz__DCEL_DATA__143');">DCEL_DATA</a>:<code>&gt; $S3 = new Array&lt;Array&lt;Int&gt;&gt;([ [1,0,2,5],[2,1,4,1],[0,2,0,3] ]);</code><code>&gt; $s = new HyperbolicSurface(DCEL_DATA=&gt;$S3);</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__FLIP_WORDS__141" onclick="swap_content('span:topaz__FLIP_WORDS__141'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__FLIP_WORDS__141" onclick="swap_content('span:topaz__FLIP_WORDS__141'); return false;"><b>FLIP_WORDS</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;List&lt;Int&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__FLIP_WORDS__141" class="foldit"><div class="descr"><p> Each Delaunay triangulations of the surface can be obtained by successively flipping edges of the triangulation <a href="#topaz__DCEL_DATA__143" onclick="unfold('span:topaz__DCEL_DATA__143');">DCEL_DATA</a>.
 The k-th flip word is a list of integers (the indices of the edges) that describe which edge flips produce the k-th Delaunay triangulation.
 Note that the k-th Delaunay triangulation also corresponds to the k-th maximal cone of the <a href="#topaz__SECONDARY_FAN__142" onclick="unfold('span:topaz__SECONDARY_FAN__142');">SECONDARY_FAN</a>.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__PENNER_COORDINATES__140" onclick="swap_content('span:topaz__PENNER_COORDINATES__140'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__PENNER_COORDINATES__140" onclick="swap_content('span:topaz__PENNER_COORDINATES__140'); return false;"><b>PENNER_COORDINATES</b>:
		</a><a href="common.html#common__Vector__306" onclick="unfold('span:common__Vector__306');">common::Vector&lt;Rational&gt;</a><br/><div style="display: inline" id="span:topaz__PENNER_COORDINATES__140" class="foldit"><div class="descr"><p> Penners lambda lenghts, sometimes called Penner coordinates, of the hyperbolic surface. 
     Robert C. Penner. Decorated Teichmüller Theory. QGM Master Class Series. European Mathematical Society, Zürich, 2012.
 They are given by one positive rational for each edge of the triangulation, ordered in the sense of the triangulation <a href="#topaz__DCEL_DATA__143" onclick="unfold('span:topaz__DCEL_DATA__143');">DCEL_DATA</a>.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__SECONDARY_FAN__142" onclick="swap_content('span:topaz__SECONDARY_FAN__142'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__SECONDARY_FAN__142" onclick="swap_content('span:topaz__SECONDARY_FAN__142'); return false;"><b>SECONDARY_FAN</b>:
		</a><a href="fan.html#fan__PolyhedralFan__68" onclick="unfold('span:fan__PolyhedralFan__68');">fan::PolyhedralFan&lt;Rational&gt;</a><br/><div style="display: inline" id="span:topaz__SECONDARY_FAN__142" class="foldit"><div class="descr"><p> The secondary fan of the hyperbolic surface.
 The k-th maximal cone corresponds to the Delaunay triangulation obtained by applying the k-th flip word of <a href="#topaz__FLIP_WORDS__141" onclick="unfold('span:topaz__FLIP_WORDS__141');">FLIP_WORDS</a>.
 See M. Joswig, R. Löwe, and B. Springborn. Secondary fans and secondary polyhedra of punctured Riemann surfaces. arXiv:1708.08714.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__SPECIAL_POINT__139" onclick="swap_content('span:topaz__SPECIAL_POINT__139'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__SPECIAL_POINT__139" onclick="swap_content('span:topaz__SPECIAL_POINT__139'); return false;"><b>SPECIAL_POINT</b>:
		</a><a href="common.html#common__Pair__317" onclick="unfold('span:common__Pair__317');">common::Pair&lt;Rational, Rational&gt;</a><br/><div style="display: inline" id="span:topaz__SPECIAL_POINT__139" class="foldit"><div class="descr"><p> In order to compute <a href="#topaz__GKZ_VECTORS__235" onclick="unfold('span:topaz__GKZ_VECTORS__235');">GKZ_VECTORS</a> (or a <a href="#topaz__secondary_polyhedron__69" onclick="unfold('span:topaz__secondary_polyhedron__69');">secondary_polyhedron</a>) one needs to specify a point on the surface, see 
     M. Joswig, R. Löwe, and B. Springborn. Secondary fans and secondary polyhedra of punctured Riemann surfaces. arXiv:1708.08714.
 This point is specified by choosing a pair of rationals (p,x) that determine how the (decorated) 0th half edge is lifted to a geodesic in H^2.
 The covering is chosen in such a way that the horocycle at infinity is the vertical line at height p^2 and 
 the lifted 0th half edge goes from infinity to the point x at the ideal boundary.</p></div></div></div></div></li></ul><h4>User Methods of HyperbolicSurface</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__Other__138" onclick="swap_content('span:topaz__Other__138'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Other__138" onclick="swap_content('span:topaz__Other__138'); return false;"><span class="category">Other</span></a></h3></div><div style="display: inline" id="span:topaz__Other__138" class="foldit"><div class="descr"><p> Special purpose methods.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__gkz_dome__236" onclick="swap_content('span:topaz__gkz_dome__236'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__gkz_dome__236" onclick="swap_content('span:topaz__gkz_dome__236'); return false;"><b>gkz_dome</b></a>
			(k, depth)  

			
				→ fan::PolyhedralComplex&lt;Rational&gt;<div style="display: inline" id="span:topaz__gkz_dome__236" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes the GKZ dome of the <em class="param">k</em>-th Delaunay trianglation up to a given <em class="param">depth</em>.
 Note that <em class="param">k</em> is also the index of the corresponding flip word in <a href="#topaz__FLIP_WORDS__141" onclick="unfold('span:topaz__FLIP_WORDS__141');">FLIP_WORDS</a>.
 Projection to the disc yields (a part of) the covering triangulation of the Klein disc.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">k</td><td><div class="descr"><div>index of the flip word  </div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">depth</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="fan.html#fan__PolyhedralComplex__65" onclick="unfold('span:fan__PolyhedralComplex__65');">fan::PolyhedralComplex&lt;Rational&gt;</a></td><td/></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr"><code>&gt; $T = new Array&lt;Array&lt;Int&gt;&gt;([[0,0,6,5],[0,0,1,10],[0,0,8,2],[1,0,11,4],[1,0,7,3],[1,0,9,0]]);</code><code>&gt; $s = new HyperbolicSurface(DCEL_DATA=&gt;$T, PENNER_COORDINATES=&gt;[1,1,1,1,1,1], SPECIAL_POINT=&gt;[1,0]);</code><code>&gt; $d = $s-&gt;gkz_dome(0,3);</code><code>&gt; $d-&gt;VISUAL;</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__GKZ_VECTORS__235" onclick="swap_content('span:topaz__GKZ_VECTORS__235'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__GKZ_VECTORS__235" onclick="swap_content('span:topaz__GKZ_VECTORS__235'); return false;"><b>GKZ_VECTORS</b></a>
			(depth)  

			
				→ Matrix&lt;Rational&gt;<div style="display: inline" id="span:topaz__GKZ_VECTORS__235" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes an approximation of the GKZ vectors of a hyperbolic surface.
 The approximation depends on the parameter <em class="param">depth</em> that restricts the depth of the (covering) triangles that are summed over in the definition of the GKZ vectors.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">depth</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Matrix__300" onclick="unfold('span:common__Matrix__300');">Matrix&lt;Rational&gt;</a></td><td/></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr"><code>&gt; $T = new Array&lt;Array&lt;Int&gt;&gt;([[0,0,6,5],[0,0,1,10],[0,0,8,2],[1,0,11,4],[1,0,7,3],[1,0,9,0]]);</code><code>&gt; $s = new HyperbolicSurface(DCEL_DATA=&gt;$T, PENNER_COORDINATES=&gt;[1,1,1,1,1,1], SPECIAL_POINT=&gt;[1,0]);</code><code>&gt; print $s-&gt;GKZ_VECTORS(2);</code><code> 1 240509/380250 517/1950</code><code> 1 98473/694950 915006978873/1469257962050</code></div></li></ul></div></div></div></div></li></ul></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__MorseMatching__33" onclick="swap_content('span:topaz__MorseMatching__33'); return false;">
		 	
	</div><div class="unfoldable"><div class="object"><h3><a href="#" class="javalink" id="topaz__MorseMatching__33" onclick="swap_content('span:topaz__MorseMatching__33'); return false;"><span class="object">MorseMatching</span></a></h3></div><div style="display: inline" id="span:topaz__MorseMatching__33" class="foldit"><b>Category: </b>Topology<br/><div class="descr"><p> A Morse matching is a reorientation of the arcs in the Hasse diagram of a simplicial complex
 such that at most one arc incident to each face is reoriented (matching condition) and the
 resulting orientation is acyclic (acyclicity condition). Morse matchings capture the main
 structure of discrete Morse functions, see</p><blockquote><div>Robin Forman: Morse Theory for Cell-Complexes,</div><div>Advances in Math., 134 (1998), pp. 90-145.</div></blockquote><p>
 This property is computed by one of two heuristics. The default heuristic is
 a simple greedy algorithm (<a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">greedy</a>). The alternative is to use a canceling algorithm
 due to Forman (<a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">cancel</a>) or both (<a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">both</a>) together. Note that the computation of a Morse matching of largest
 size is NP-hard. See</p><blockquote><div>Michael Joswig, Marc E. Pfetsch: Computing Optimal Morse Matchings</div><div>SIAM J. Discrete Math., 2006, to appear</div></blockquote></div><div class="level3"/><h4>Properties of MorseMatching</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__CRITICAL_FACES__162" onclick="swap_content('span:topaz__CRITICAL_FACES__162'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__CRITICAL_FACES__162" onclick="swap_content('span:topaz__CRITICAL_FACES__162'); return false;"><b>CRITICAL_FACES</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Set&lt;Int&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__CRITICAL_FACES__162" class="foldit"><div class="descr"><p> The critical faces of the computed Morse matching, i.e., the faces not
 incident to any reoriented arc (not matched).</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__CRITICAL_FACE_VECTOR__164" onclick="swap_content('span:topaz__CRITICAL_FACE_VECTOR__164'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__CRITICAL_FACE_VECTOR__164" onclick="swap_content('span:topaz__CRITICAL_FACE_VECTOR__164'); return false;"><b>CRITICAL_FACE_VECTOR</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Int&gt;</a><br/><div style="display: inline" id="span:topaz__CRITICAL_FACE_VECTOR__164" class="foldit"><div class="descr"><p> The vector of critical faces in each dimension.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__N_CRITICAL_FACES__163" onclick="swap_content('span:topaz__N_CRITICAL_FACES__163'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__N_CRITICAL_FACES__163" onclick="swap_content('span:topaz__N_CRITICAL_FACES__163'); return false;"><b>N_CRITICAL_FACES</b>:
		</a><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">common::Int</a><br/><div style="display: inline" id="span:topaz__N_CRITICAL_FACES__163" class="foldit"><div class="descr"><p> Number of critical faces of the computed Morse matching.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__SIZE__165" onclick="swap_content('span:topaz__SIZE__165'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__SIZE__165" onclick="swap_content('span:topaz__SIZE__165'); return false;"><b>SIZE</b>:
		</a><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">common::Int</a><br/><div style="display: inline" id="span:topaz__SIZE__165" class="foldit"><div class="descr"><p> Size of the computed Morse matching.</p></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__SimplicialComplex__9" onclick="swap_content('span:topaz__SimplicialComplex__9'); return false;">
		 	
	</div><div class="unfoldable"><div class="object"><h3><a href="#" class="javalink" id="topaz__SimplicialComplex__9" onclick="swap_content('span:topaz__SimplicialComplex__9'); return false;"><span class="object">SimplicialComplex</span></a></h3></div><div style="display: inline" id="span:topaz__SimplicialComplex__9" class="foldit"><div class="descr"><p> An abstract simplicial complex represented by its facets.</p></div><div class="level3"/><h4>Properties of SimplicialComplex</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__Combinatorics__128" onclick="swap_content('span:topaz__Combinatorics__128'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Combinatorics__128" onclick="swap_content('span:topaz__Combinatorics__128'); return false;"><span class="category">Combinatorics</span></a></h3></div><div style="display: inline" id="span:topaz__Combinatorics__128" class="foldit"><div class="descr"><p> These properties capture combinatorial information of the object. 
 Combinatorial properties only depend on combinatorial data of the object like, e.g., the face lattice.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__BOUNDARY__175" onclick="swap_content('span:topaz__BOUNDARY__175'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__BOUNDARY__175" onclick="swap_content('span:topaz__BOUNDARY__175'); return false;"><b>BOUNDARY</b>:
		</a><a href="#topaz__BOUNDARY__175" onclick="unfold('span:topaz__BOUNDARY__175');">SimplicialComplex as SimplicialComplex::BOUNDARY</a><br/><div style="display: inline" id="span:topaz__BOUNDARY__175" class="foldit"><div class="descr"><p> Codimension-1-faces of a <a href="#topaz__PSEUDO_MANIFOLD__208" onclick="unfold('span:topaz__PSEUDO_MANIFOLD__208');">PSEUDO_MANIFOLD</a> which are contained in one facet only.</p></div><h4>Properties of BOUNDARY</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__Combinatorics__251" onclick="swap_content('span:topaz__Combinatorics__251'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Combinatorics__251" onclick="swap_content('span:topaz__Combinatorics__251'); return false;"><span class="category">Combinatorics</span></a></h3></div><div style="display: inline" id="span:topaz__Combinatorics__251" class="foldit"><div class="descr"><p> These properties capture combinatorial information of the object. 
 Combinatorial properties only depend on combinatorial data of the object like, e.g., the face lattice.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__VERTEX_MAP__256" onclick="swap_content('span:topaz__VERTEX_MAP__256'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VERTEX_MAP__256" onclick="swap_content('span:topaz__VERTEX_MAP__256'); return false;"><b>VERTEX_MAP</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Int&gt;</a><br/><div style="display: inline" id="span:topaz__VERTEX_MAP__256" class="foldit"><div class="descr"><p> Maps vertices of the boundary complex to the corresponding ones in the supercomplex</p></div></div></div></div></li></ul></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__COLORING__179" onclick="swap_content('span:topaz__COLORING__179'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__COLORING__179" onclick="swap_content('span:topaz__COLORING__179'); return false;"><b>COLORING</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Int&gt;</a><br/><div style="display: inline" id="span:topaz__COLORING__179" class="foldit"><div class="descr"><p> A coloring of the vertices.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__DIM__177" onclick="swap_content('span:topaz__DIM__177'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__DIM__177" onclick="swap_content('span:topaz__DIM__177'); return false;"><b>DIM</b>:
		</a><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">common::Int</a><br/><div style="display: inline" id="span:topaz__DIM__177" class="foldit"><div class="descr"><p> Maximal dimension of the <a href="#topaz__FACETS__184" onclick="unfold('span:topaz__FACETS__184');">FACETS</a>, where the dimension of a facet is defined as
 the number of its vertices minus one.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__DUAL_GRAPH__174" onclick="swap_content('span:topaz__DUAL_GRAPH__174'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__DUAL_GRAPH__174" onclick="swap_content('span:topaz__DUAL_GRAPH__174'); return false;"><b>DUAL_GRAPH</b>:
		</a><a href="#topaz__DUAL_GRAPH__174" onclick="unfold('span:topaz__DUAL_GRAPH__174');">Graph&lt;Undirected&gt; as SimplicialComplex::DUAL_GRAPH</a><br/><div style="display: inline" id="span:topaz__DUAL_GRAPH__174" class="foldit"><div class="descr"><p> The graph of facet neighborhood.
 Two <a href="#topaz__FACETS__184" onclick="unfold('span:topaz__FACETS__184');">FACETS</a> are neighbors if they share a (d-1)-dimensional face.</p></div><h4>Properties of DUAL_GRAPH</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__COLORING__250" onclick="swap_content('span:topaz__COLORING__250'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__COLORING__250" onclick="swap_content('span:topaz__COLORING__250'); return false;"><b>COLORING</b>:
		</a><a href="common.html#common__NodeMap__314" onclick="unfold('span:common__NodeMap__314');">common::NodeMap&lt;Undirected, Int&gt;</a><br/><div style="display: inline" id="span:topaz__COLORING__250" class="foldit"><div class="undoc"><p>UNDOCUMENTED</p></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__F2_VECTOR__172" onclick="swap_content('span:topaz__F2_VECTOR__172'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__F2_VECTOR__172" onclick="swap_content('span:topaz__F2_VECTOR__172'); return false;"><b>F2_VECTOR</b>:
		</a><a href="common.html#common__Matrix__300" onclick="unfold('span:common__Matrix__300');">common::Matrix&lt;Int, NonSymmetric&gt;</a><br/><div style="display: inline" id="span:topaz__F2_VECTOR__172" class="foldit"><div class="descr"><p> f<sub>ik</sub> is the number of incident pairs of i-faces and k-faces; the main
 diagonal contains the <a href="#topaz__F_VECTOR__183" onclick="unfold('span:topaz__F_VECTOR__183');">F_VECTOR</a>.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__FACETS__184" onclick="swap_content('span:topaz__FACETS__184'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__FACETS__184" onclick="swap_content('span:topaz__FACETS__184'); return false;"><b>FACETS</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Set&lt;Int&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__FACETS__184" class="foldit"><div class="descr"><p> Faces which are maximal with respect to inclusion, encoded as their ordered set of vertices.
 The vertices must be numbered 0, ..., n-1.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__FOLDABLE__176" onclick="swap_content('span:topaz__FOLDABLE__176'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__FOLDABLE__176" onclick="swap_content('span:topaz__FOLDABLE__176'); return false;"><b>FOLDABLE</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__FOLDABLE__176" class="foldit"><div class="descr"><p> True if <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a> is (<a href="#topaz__DIM__177" onclick="unfold('span:topaz__DIM__177');">DIM</a> + 1)-colorable.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__F_VECTOR__183" onclick="swap_content('span:topaz__F_VECTOR__183'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__F_VECTOR__183" onclick="swap_content('span:topaz__F_VECTOR__183'); return false;"><b>F_VECTOR</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Int&gt;</a><br/><div style="display: inline" id="span:topaz__F_VECTOR__183" class="foldit"><div class="descr"><p> f<sub>k</sub> is the number of k-faces, for k = 0,... , d, where d is the dimension.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__GRAPH__185" onclick="swap_content('span:topaz__GRAPH__185'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__GRAPH__185" onclick="swap_content('span:topaz__GRAPH__185'); return false;"><b>GRAPH</b>:
		</a><a href="graph.html#graph__Graph__77" onclick="unfold('span:graph__Graph__77');">graph::Graph&lt;Undirected&gt;</a><br/><div style="display: inline" id="span:topaz__GRAPH__185" class="foldit"><div class="descr"><p> The subcomplex consisting of all 1-faces.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__HASSE_DIAGRAM__181" onclick="swap_content('span:topaz__HASSE_DIAGRAM__181'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__HASSE_DIAGRAM__181" onclick="swap_content('span:topaz__HASSE_DIAGRAM__181'); return false;"><b>HASSE_DIAGRAM</b>:
		</a><a href="#topaz__HASSE_DIAGRAM__181" onclick="unfold('span:topaz__HASSE_DIAGRAM__181');">Lattice&lt;BasicDecoration, Nonsequential&gt; as SimplicialComplex::HASSE_DIAGRAM</a><br/><div style="display: inline" id="span:topaz__HASSE_DIAGRAM__181" class="foldit"><div class="descr"><p> The face lattice of the simplical complex
 organized as a directed graph.  Each node corresponds to some face
 of the simplical complex. It is represented as the list of vertices
 comprising the face. The outgoing arcs point to the containing faces
 of the next dimension. An artificial top node is added to represent
 the entire complex.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__H_VECTOR__170" onclick="swap_content('span:topaz__H_VECTOR__170'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__H_VECTOR__170" onclick="swap_content('span:topaz__H_VECTOR__170'); return false;"><b>H_VECTOR</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Int&gt;</a><br/><div style="display: inline" id="span:topaz__H_VECTOR__170" class="foldit"><div class="descr"><p> The h-vector of the simplicial complex.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__MINIMAL_NON_FACES__188" onclick="swap_content('span:topaz__MINIMAL_NON_FACES__188'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__MINIMAL_NON_FACES__188" onclick="swap_content('span:topaz__MINIMAL_NON_FACES__188'); return false;"><b>MINIMAL_NON_FACES</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Set&lt;Int&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__MINIMAL_NON_FACES__188" class="foldit"><div class="descr"><p> Inclusion minimal non-faces (vertex subsets which are not faces of the simplicial complex).</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__N_FACETS__171" onclick="swap_content('span:topaz__N_FACETS__171'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__N_FACETS__171" onclick="swap_content('span:topaz__N_FACETS__171'); return false;"><b>N_FACETS</b>:
		</a><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">common::Int</a><br/><div style="display: inline" id="span:topaz__N_FACETS__171" class="foldit"><div class="descr"><p> Number of <a href="#topaz__FACETS__184" onclick="unfold('span:topaz__FACETS__184');">FACETS</a>.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__N_MINIMAL_NON_FACES__187" onclick="swap_content('span:topaz__N_MINIMAL_NON_FACES__187'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__N_MINIMAL_NON_FACES__187" onclick="swap_content('span:topaz__N_MINIMAL_NON_FACES__187'); return false;"><b>N_MINIMAL_NON_FACES</b>:
		</a><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">common::Int</a><br/><div style="display: inline" id="span:topaz__N_MINIMAL_NON_FACES__187" class="foldit"><div class="descr"><p> Number of <a href="#topaz__MINIMAL_NON_FACES__188" onclick="unfold('span:topaz__MINIMAL_NON_FACES__188');">MINIMAL_NON_FACES</a>.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__N_VERTICES__173" onclick="swap_content('span:topaz__N_VERTICES__173'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__N_VERTICES__173" onclick="swap_content('span:topaz__N_VERTICES__173'); return false;"><b>N_VERTICES</b>:
		</a><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">common::Int</a><br/><div style="display: inline" id="span:topaz__N_VERTICES__173" class="foldit"><div class="descr"><p> Number of vertices.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__ODD_SUBCOMPLEX__191" onclick="swap_content('span:topaz__ODD_SUBCOMPLEX__191'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__ODD_SUBCOMPLEX__191" onclick="swap_content('span:topaz__ODD_SUBCOMPLEX__191'); return false;"><b>ODD_SUBCOMPLEX</b>:
		</a><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a><br/><div style="display: inline" id="span:topaz__ODD_SUBCOMPLEX__191" class="foldit"><div class="descr"><p> Subcomplex generated by faces of codimension 2 that are contained in an odd
 number of faces of codimension 1.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__PROJ_DICTIONARY__190" onclick="swap_content('span:topaz__PROJ_DICTIONARY__190'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__PROJ_DICTIONARY__190" onclick="swap_content('span:topaz__PROJ_DICTIONARY__190'); return false;"><b>PROJ_DICTIONARY</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Int&gt;</a><br/><div style="display: inline" id="span:topaz__PROJ_DICTIONARY__190" class="foldit"><div class="descr"><p> For each vertex the corresponding vertex of facet 0 with respect to the action of the group of projectivities.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__PROJ_ORBITS__186" onclick="swap_content('span:topaz__PROJ_ORBITS__186'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__PROJ_ORBITS__186" onclick="swap_content('span:topaz__PROJ_ORBITS__186'); return false;"><b>PROJ_ORBITS</b>:
		</a><a href="common.html#common__PowerSet__273" onclick="unfold('span:common__PowerSet__273');">common::PowerSet&lt;Int&gt;</a><br/><div style="display: inline" id="span:topaz__PROJ_ORBITS__186" class="foldit"><div class="descr"><p> Orbit decomposition of the group of projectivities acting on the set of vertices of facet 0.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__PURE__178" onclick="swap_content('span:topaz__PURE__178'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__PURE__178" onclick="swap_content('span:topaz__PURE__178'); return false;"><b>PURE</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__PURE__178" class="foldit"><div class="descr"><p> A simplicial complex is <em class="u">pure</em> if all its facets have the same dimension.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__SHELLABLE__182" onclick="swap_content('span:topaz__SHELLABLE__182'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__SHELLABLE__182" onclick="swap_content('span:topaz__SHELLABLE__182'); return false;"><b>SHELLABLE</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__SHELLABLE__182" class="foldit"><div class="descr"><p> True if this is shellable.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__SHELLING__189" onclick="swap_content('span:topaz__SHELLING__189'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__SHELLING__189" onclick="swap_content('span:topaz__SHELLING__189'); return false;"><b>SHELLING</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Set&lt;Int&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__SHELLING__189" class="foldit"><div class="descr"><p> An ordered list of facets constituting a shelling.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__VERTEX_INDICES__180" onclick="swap_content('span:topaz__VERTEX_INDICES__180'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VERTEX_INDICES__180" onclick="swap_content('span:topaz__VERTEX_INDICES__180'); return false;"><b>VERTEX_INDICES</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Int&gt;</a><br/><div style="display: inline" id="span:topaz__VERTEX_INDICES__180" class="foldit"><div class="descr"><p> Indices of the vertices from <a href="#topaz__INPUT_FACES__167" onclick="unfold('span:topaz__INPUT_FACES__167');">INPUT_FACES</a>.  That is, the map i \mapsto v_i.</p></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Input_property__126" onclick="swap_content('span:topaz__Input_property__126'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Input_property__126" onclick="swap_content('span:topaz__Input_property__126'); return false;"><span class="category">Input property</span></a></h3></div><div style="display: inline" id="span:topaz__Input_property__126" class="foldit"><div class="descr"><p> These properties are for input only. They allow redundant information.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__INPUT_FACES__167" onclick="swap_content('span:topaz__INPUT_FACES__167'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__INPUT_FACES__167" onclick="swap_content('span:topaz__INPUT_FACES__167'); return false;"><b>INPUT_FACES</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Set&lt;Int&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__INPUT_FACES__167" class="foldit"><div class="descr"><p> Any description of the faces of a simplicial complex with vertices v_0 &lt; v_1 &lt; v_2 &lt; ... arbitrary.  Redundant faces allowed.</p></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Symmetry__125" onclick="swap_content('span:topaz__Symmetry__125'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Symmetry__125" onclick="swap_content('span:topaz__Symmetry__125'); return false;"><span class="category">Symmetry</span></a></h3></div><div style="display: inline" id="span:topaz__Symmetry__125" class="foldit"><div class="descr"><p> These properties capture information of the object that is concerned with the action of permutation groups.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__GROUP__166" onclick="swap_content('span:topaz__GROUP__166'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__GROUP__166" onclick="swap_content('span:topaz__GROUP__166'); return false;"><b>GROUP</b>:
		</a><a href="group.html#group__Group__20" onclick="unfold('span:group__Group__20');">Group as SimplicialComplex::GROUP</a><br/><div style="display: inline" id="span:topaz__GROUP__166" class="foldit"><div class="undoc">UNDOCUMENTED</div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Topology__129" onclick="swap_content('span:topaz__Topology__129'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Topology__129" onclick="swap_content('span:topaz__Topology__129'); return false;"><span class="category">Topology</span></a></h3></div><div style="display: inline" id="span:topaz__Topology__129" class="foldit"><div class="descr"><p> The following properties are topological invariants.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__BALL__193" onclick="swap_content('span:topaz__BALL__193'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__BALL__193" onclick="swap_content('span:topaz__BALL__193'); return false;"><b>BALL</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__BALL__193" class="foldit"><div class="descr"><p> Determines if this is homeomorphic to a ball.
 In general, this is undecidable; therefore, the implementation depends on heuristics.
 May be true or false or undef (if heuristic does not succeed).</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__CLOSED_PSEUDO_MANIFOLD__203" onclick="swap_content('span:topaz__CLOSED_PSEUDO_MANIFOLD__203'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__CLOSED_PSEUDO_MANIFOLD__203" onclick="swap_content('span:topaz__CLOSED_PSEUDO_MANIFOLD__203'); return false;"><b>CLOSED_PSEUDO_MANIFOLD</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__CLOSED_PSEUDO_MANIFOLD__203" class="foldit"><div class="descr"><p> True if this is a <a href="#topaz__PURE__178" onclick="unfold('span:topaz__PURE__178');">PURE</a> simplicial complex with the property that each ridge is
 contained in exactly two facets.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__COCYCLES__210" onclick="swap_content('span:topaz__COCYCLES__210'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__COCYCLES__210" onclick="swap_content('span:topaz__COCYCLES__210'); return false;"><b>COCYCLES</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;CycleGroup&lt;Integer&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__COCYCLES__210" class="foldit"><div class="descr"><p> Representatives of cocycle groups, listed in increasing codimension order.
 See <a href="#topaz__CycleGroup__111" onclick="unfold('span:topaz__CycleGroup__111');">CycleGroup</a> for explanation of encoding of each group.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__COHOMOLOGY__201" onclick="swap_content('span:topaz__COHOMOLOGY__201'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__COHOMOLOGY__201" onclick="swap_content('span:topaz__COHOMOLOGY__201'); return false;"><b>COHOMOLOGY</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;HomologyGroup&lt;Integer&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__COHOMOLOGY__201" class="foldit"><div class="descr"><p> Reduced cohomology groups, listed in increasing codimension order.
 See <a href="#topaz__HomologyGroup__108" onclick="unfold('span:topaz__HomologyGroup__108');">HomologyGroup</a> for explanation of encoding of each group.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__CYCLES__195" onclick="swap_content('span:topaz__CYCLES__195'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__CYCLES__195" onclick="swap_content('span:topaz__CYCLES__195'); return false;"><b>CYCLES</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;CycleGroup&lt;Integer&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__CYCLES__195" class="foldit"><div class="descr"><p> Representatives of cycle groups, listed in increasing dimension order.
 See <a href="#topaz__CycleGroup__111" onclick="unfold('span:topaz__CycleGroup__111');">CycleGroup</a> for explanation of encoding of each group.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__EULER_CHARACTERISTIC__200" onclick="swap_content('span:topaz__EULER_CHARACTERISTIC__200'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__EULER_CHARACTERISTIC__200" onclick="swap_content('span:topaz__EULER_CHARACTERISTIC__200'); return false;"><b>EULER_CHARACTERISTIC</b>:
		</a><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">common::Int</a><br/><div style="display: inline" id="span:topaz__EULER_CHARACTERISTIC__200" class="foldit"><div class="descr"><p> Reduced Euler characteristic.  Alternating sum of the <a href="#topaz__F_VECTOR__183" onclick="unfold('span:topaz__F_VECTOR__183');">F_VECTOR</a> minus 1.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__FUNDAMENTAL_GROUP__198" onclick="swap_content('span:topaz__FUNDAMENTAL_GROUP__198'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__FUNDAMENTAL_GROUP__198" onclick="swap_content('span:topaz__FUNDAMENTAL_GROUP__198'); return false;"><b>FUNDAMENTAL_GROUP</b>:
		</a><a href="common.html#common__Pair__317" onclick="unfold('span:common__Pair__317');">common::Pair&lt;Int, List&lt;List&lt;Pair&lt;Int, Int&gt;&gt;&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__FUNDAMENTAL_GROUP__198" class="foldit"><div class="descr"><p> A finite representation of the fundamental group.
 The fundamental group is represented as a pair of an integer,
 the number of generators, and a list of relations. The generators are numbered
 consecutively starting with zero. A relation is encoded as a list of pairs,
 each pair consisting of a generator and its exponent.</p><p> You may use the <a href="#topaz__fundamental2gap__233" onclick="unfold('span:topaz__fundamental2gap__233');">fundamental2gap</a> method to produce a <code>GAP</code> file.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__FUNDAMENTAL_GROUP_GEN_LABELS__199" onclick="swap_content('span:topaz__FUNDAMENTAL_GROUP_GEN_LABELS__199'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__FUNDAMENTAL_GROUP_GEN_LABELS__199" onclick="swap_content('span:topaz__FUNDAMENTAL_GROUP_GEN_LABELS__199'); return false;"><b>FUNDAMENTAL_GROUP_GEN_LABELS</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;String&gt;</a><br/><div style="display: inline" id="span:topaz__FUNDAMENTAL_GROUP_GEN_LABELS__199" class="foldit"><div class="descr"><p> Labels of the generators of the <a href="#topaz__FUNDAMENTAL_GROUP__198" onclick="unfold('span:topaz__FUNDAMENTAL_GROUP__198');">FUNDAMENTAL_GROUP</a>.
 The labels can be chosen freely. If the <a href="#topaz__FUNDAMENTAL_GROUP__198" onclick="unfold('span:topaz__FUNDAMENTAL_GROUP__198');">FUNDAMENTAL_GROUP</a> is computed
 by polymake, the generators correspond to the edges of the
 complex. Hence they are labeled <code>g</code> followed by the vertices of the edge, e.g.
 <code>g3_6</code> corresponds to the edge {3 6}.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__GENUS__211" onclick="swap_content('span:topaz__GENUS__211'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__GENUS__211" onclick="swap_content('span:topaz__GENUS__211'); return false;"><b>GENUS</b>:
		</a><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">common::Int</a><br/><div style="display: inline" id="span:topaz__GENUS__211" class="foldit"><div class="descr"><p> The <em class="u">genus</em> of a surface.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__HOMOLOGY__197" onclick="swap_content('span:topaz__HOMOLOGY__197'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__HOMOLOGY__197" onclick="swap_content('span:topaz__HOMOLOGY__197'); return false;"><b>HOMOLOGY</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;HomologyGroup&lt;Integer&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__HOMOLOGY__197" class="foldit"><div class="descr"><p> Reduced simplicial homology groups H<sub>0</sub>, ..., H<sub>d</sub> (integer coefficients), listed in increasing dimension order.
 See <a href="#topaz__HomologyGroup__108" onclick="unfold('span:topaz__HomologyGroup__108');">HomologyGroup</a> for explanation of encoding of each group.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__INTERSECTION_FORM__206" onclick="swap_content('span:topaz__INTERSECTION_FORM__206'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__INTERSECTION_FORM__206" onclick="swap_content('span:topaz__INTERSECTION_FORM__206'); return false;"><b>INTERSECTION_FORM</b>:
		</a><a href="#topaz__IntersectionForm__113" onclick="unfold('span:topaz__IntersectionForm__113');">IntersectionForm</a><br/><div style="display: inline" id="span:topaz__INTERSECTION_FORM__206" class="foldit"><div class="descr"><p> The integral quadratic form obtained from restricting the multiplication of the cohomology of a closed
 4k-manifold to H^{2k} x H^{2k} -&gt; H^{4k} = Z.  As a quadratic form over the reals it is characterized
 by its dimension and its index of inertia (or, equivalenty, by the number of positive and negative ones
 in its canonical form).  An integral quadratic form is even if it takes values in 2Z.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__KNOT__202" onclick="swap_content('span:topaz__KNOT__202'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__KNOT__202" onclick="swap_content('span:topaz__KNOT__202'); return false;"><b>KNOT</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Set&lt;Int&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__KNOT__202" class="foldit"><div class="descr"><p> Edge-subset of a 3-sphere which is a knot or link, that is, a collection of pairwise disjoint cycles.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__LOCALLY_STRONGLY_CONNECTED__196" onclick="swap_content('span:topaz__LOCALLY_STRONGLY_CONNECTED__196'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__LOCALLY_STRONGLY_CONNECTED__196" onclick="swap_content('span:topaz__LOCALLY_STRONGLY_CONNECTED__196'); return false;"><b>LOCALLY_STRONGLY_CONNECTED</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__LOCALLY_STRONGLY_CONNECTED__196" class="foldit"><div class="descr"><p> True if the vertex star of each vertex is <a href="#topaz__DUAL_CONNECTED__232" onclick="unfold('span:topaz__DUAL_CONNECTED__232');">DUAL_CONNECTED</a>.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__MANIFOLD__207" onclick="swap_content('span:topaz__MANIFOLD__207'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__MANIFOLD__207" onclick="swap_content('span:topaz__MANIFOLD__207'); return false;"><b>MANIFOLD</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__MANIFOLD__207" class="foldit"><div class="descr"><p> Determines if this is a compact simplicial manifold with boundary.
 Depends on heuristic <a href="#topaz__SPHERE__194" onclick="unfold('span:topaz__SPHERE__194');">SPHERE</a> recognition.
 May be true or false or undef (if heuristic does not succeed).</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__MORSE_MATCHING__212" onclick="swap_content('span:topaz__MORSE_MATCHING__212'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__MORSE_MATCHING__212" onclick="swap_content('span:topaz__MORSE_MATCHING__212'); return false;"><b>MORSE_MATCHING</b>:
		</a><a href="#topaz__MORSE_MATCHING__212" onclick="unfold('span:topaz__MORSE_MATCHING__212');">MorseMatching as SimplicialComplex::MORSE_MATCHING</a><br/><div style="display: inline" id="span:topaz__MORSE_MATCHING__212" class="foldit"><div class="descr"><p> Morse matching in the Hasse diagram of the simplicial complex</p></div><h4>Properties of MORSE_MATCHING</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__MATCHING__255" onclick="swap_content('span:topaz__MATCHING__255'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__MATCHING__255" onclick="swap_content('span:topaz__MATCHING__255'); return false;"><b>MATCHING</b>:
		</a><a href="common.html#common__EdgeMap__311" onclick="unfold('span:common__EdgeMap__311');">common::EdgeMap&lt;Directed, Int&gt;</a><br/><div style="display: inline" id="span:topaz__MATCHING__255" class="foldit"><div class="descr"><p> The matching in the HasseDiagram of the SimplicialComplex</p></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__ORIENTATION__204" onclick="swap_content('span:topaz__ORIENTATION__204'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__ORIENTATION__204" onclick="swap_content('span:topaz__ORIENTATION__204'); return false;"><b>ORIENTATION</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;Bool&gt;</a><br/><div style="display: inline" id="span:topaz__ORIENTATION__204" class="foldit"><div class="descr"><p> An orientation of the facets of an <a href="#topaz__ORIENTED_PSEUDO_MANIFOLD__209" onclick="unfold('span:topaz__ORIENTED_PSEUDO_MANIFOLD__209');">ORIENTED_PSEUDO_MANIFOLD</a>, such that the induced orientations
 of a common ridge of two neighboring facets cancel each other out. Each facet is marked with <em class="param">true</em>
 if the orientation agrees with the (chosen) orientation of the first facet, and is marked with <em class="param">false</em> otherwise.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__ORIENTED_PSEUDO_MANIFOLD__209" onclick="swap_content('span:topaz__ORIENTED_PSEUDO_MANIFOLD__209'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__ORIENTED_PSEUDO_MANIFOLD__209" onclick="swap_content('span:topaz__ORIENTED_PSEUDO_MANIFOLD__209'); return false;"><b>ORIENTED_PSEUDO_MANIFOLD</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__ORIENTED_PSEUDO_MANIFOLD__209" class="foldit"><div class="descr"><p> True if this is a <a href="#topaz__PSEUDO_MANIFOLD__208" onclick="unfold('span:topaz__PSEUDO_MANIFOLD__208');">PSEUDO_MANIFOLD</a> with top level homology isomorphic to Z.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__PSEUDO_MANIFOLD__208" onclick="swap_content('span:topaz__PSEUDO_MANIFOLD__208'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__PSEUDO_MANIFOLD__208" onclick="swap_content('span:topaz__PSEUDO_MANIFOLD__208'); return false;"><b>PSEUDO_MANIFOLD</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__PSEUDO_MANIFOLD__208" class="foldit"><div class="descr"><p> True if this is a <a href="#topaz__PURE__178" onclick="unfold('span:topaz__PURE__178');">PURE</a> simplicial complex with the property that each ridge is
 contained in either one or two facets.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__SPHERE__194" onclick="swap_content('span:topaz__SPHERE__194'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__SPHERE__194" onclick="swap_content('span:topaz__SPHERE__194'); return false;"><b>SPHERE</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__SPHERE__194" class="foldit"><div class="descr"><p> Determines if this is homeomorphic to a sphere.
 In general, this is undecidable; therefore, the implementation depends on heuristics.
 May be true or false or undef (if heuristic does not succeed).</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__STIEFEL_WHITNEY__205" onclick="swap_content('span:topaz__STIEFEL_WHITNEY__205'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__STIEFEL_WHITNEY__205" onclick="swap_content('span:topaz__STIEFEL_WHITNEY__205'); return false;"><b>STIEFEL_WHITNEY</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;PowerSet&lt;Int&gt;&gt;</a><br/><div style="display: inline" id="span:topaz__STIEFEL_WHITNEY__205" class="foldit"><div class="descr"><p> Mod 2 cycle representation of Stiefel-Whitney classes.  Each cycle is represented as a set of simplices.</p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__SURFACE__192" onclick="swap_content('span:topaz__SURFACE__192'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__SURFACE__192" onclick="swap_content('span:topaz__SURFACE__192'); return false;"><b>SURFACE</b>:
		</a><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">common::Bool</a><br/><div style="display: inline" id="span:topaz__SURFACE__192" class="foldit"><div class="descr"><p> True if this is a <a href="#topaz__CONNECTED__234" onclick="unfold('span:topaz__CONNECTED__234');">CONNECTED</a> <a href="#topaz__MANIFOLD__207" onclick="unfold('span:topaz__MANIFOLD__207');">MANIFOLD</a> of dimension 2.</p></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Visualization__127" onclick="swap_content('span:topaz__Visualization__127'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Visualization__127" onclick="swap_content('span:topaz__Visualization__127'); return false;"><span class="category">Visualization</span></a></h3></div><div style="display: inline" id="span:topaz__Visualization__127" class="foldit"><div class="descr"><p> These properties are for visualization.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__MIXED_GRAPH__168" onclick="swap_content('span:topaz__MIXED_GRAPH__168'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__MIXED_GRAPH__168" onclick="swap_content('span:topaz__MIXED_GRAPH__168'); return false;"><b>MIXED_GRAPH</b>:
		</a><a href="#topaz__MIXED_GRAPH__168" onclick="unfold('span:topaz__MIXED_GRAPH__168');">Graph&lt;Undirected&gt; as SimplicialComplex::MIXED_GRAPH</a><br/><div style="display: inline" id="span:topaz__MIXED_GRAPH__168" class="foldit"><div class="descr"><p> The nodes of the mixed graph are the nodes of the primal <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a> and
 the <a href="#topaz__DUAL_GRAPH__174" onclick="unfold('span:topaz__DUAL_GRAPH__174');">DUAL_GRAPH</a>. Additional to the primal and dual edges, there is
 an edge between a primal and a dual node iff the primal node represents
 a vertex of the corresponding facet of the dual node.</p></div><h4>Properties of MIXED_GRAPH</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__EDGE_WEIGHTS__249" onclick="swap_content('span:topaz__EDGE_WEIGHTS__249'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__EDGE_WEIGHTS__249" onclick="swap_content('span:topaz__EDGE_WEIGHTS__249'); return false;"><b>EDGE_WEIGHTS</b>:
		</a><a href="common.html#common__EdgeMap__311" onclick="unfold('span:common__EdgeMap__311');">common::EdgeMap&lt;Undirected, Float&gt;</a><br/><div style="display: inline" id="span:topaz__EDGE_WEIGHTS__249" class="foldit"><div class="descr"><p> Associated edge weights.</p></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__VERTEX_LABELS__169" onclick="swap_content('span:topaz__VERTEX_LABELS__169'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VERTEX_LABELS__169" onclick="swap_content('span:topaz__VERTEX_LABELS__169'); return false;"><b>VERTEX_LABELS</b>:
		</a><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">common::Array&lt;String&gt;</a><br/><div style="display: inline" id="span:topaz__VERTEX_LABELS__169" class="foldit"><div class="descr"><p> Labels of the vertices.</p></div></div></div></div></li></ul></div></div></div></li></ul><h4>User Methods of SimplicialComplex</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__Combinatorics__131" onclick="swap_content('span:topaz__Combinatorics__131'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Combinatorics__131" onclick="swap_content('span:topaz__Combinatorics__131'); return false;"><span class="category">Combinatorics</span></a></h3></div><div style="display: inline" id="span:topaz__Combinatorics__131" class="foldit"><div class="descr"><p> These methods capture combinatorial information of the object. 
 Combinatorial properties only depend on combinatorial data of the object like, e.g., the face lattice.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__BIPARTITE__221" onclick="swap_content('span:topaz__BIPARTITE__221'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__BIPARTITE__221" onclick="swap_content('span:topaz__BIPARTITE__221'); return false;"><b>BIPARTITE</b></a>
			()  

			
				→ Bool<div style="display: inline" id="span:topaz__BIPARTITE__221" class="foldit"><br/><div class="descr_func"><div class="descr"><p> True if <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a> is a <em class="u">bipartite</em>. </p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__boundary_matrix__224" onclick="swap_content('span:topaz__boundary_matrix__224'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__boundary_matrix__224" onclick="swap_content('span:topaz__boundary_matrix__224'); return false;"><b>boundary_matrix</b></a>
			(d)  

			
				→ SparseMatrix&lt;Integer&gt;<div style="display: inline" id="span:topaz__boundary_matrix__224" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Output the boundary matrix of dimension <em class="u">d</em>. Indexing is according to
 the face indices in the HASSE_DIAGRAM of the complex.
 The matrix is a map via multiplying it to a vector from the <em class="u">left</em>.
 Beware, this computes the whole face lattice of your complex, which is expensive.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">d</td><td><div class="descr"><div>Dimension of the boundary matrix.</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__SparseMatrix__308" onclick="unfold('span:common__SparseMatrix__308');">SparseMatrix&lt;Integer&gt;</a></td><td/></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">This prints the boundary matrix of the 3-simplex:<code>&gt; print simplex(3)-&gt;boundary_matrix(1);</code><code> -1 1 0 0</code><code> -1 0 1 0</code><code> 0 -1 1 0</code><code> -1 0 0 1</code><code> 0 -1 0 1</code><code> 0 0 -1 1</code> The output can be interpreted like this: the zeroth column of the matrix corresponds
 to the facet with index 0, which contains the edges with indices 0,1 and 3.</div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__CONNECTED_COMPONENTS__225" onclick="swap_content('span:topaz__CONNECTED_COMPONENTS__225'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__CONNECTED_COMPONENTS__225" onclick="swap_content('span:topaz__CONNECTED_COMPONENTS__225'); return false;"><b>CONNECTED_COMPONENTS</b></a>
			()  

			
				→ PowerSet&lt;Int&gt;<div style="display: inline" id="span:topaz__CONNECTED_COMPONENTS__225" class="foldit"><br/><div class="descr_func"><div class="descr"><p> The connected components of the <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a>, encoded as node sets. </p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__PowerSet__273" onclick="unfold('span:common__PowerSet__273');">PowerSet&lt;Int&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__CONNECTIVITY__230" onclick="swap_content('span:topaz__CONNECTIVITY__230'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__CONNECTIVITY__230" onclick="swap_content('span:topaz__CONNECTIVITY__230'); return false;"><b>CONNECTIVITY</b></a>
			()  

			
				→ Int<div style="display: inline" id="span:topaz__CONNECTIVITY__230" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Node connectivity of the <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a>, that is, the minimal number of nodes to be removed from the graph such that the result is disconnected.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__DUAL_BIPARTITE__229" onclick="swap_content('span:topaz__DUAL_BIPARTITE__229'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__DUAL_BIPARTITE__229" onclick="swap_content('span:topaz__DUAL_BIPARTITE__229'); return false;"><b>DUAL_BIPARTITE</b></a>
			()  

			
				→ Bool<div style="display: inline" id="span:topaz__DUAL_BIPARTITE__229" class="foldit"><br/><div class="descr_func"><div class="descr"><p> True if <a href="#topaz__DUAL_GRAPH__174" onclick="unfold('span:topaz__DUAL_GRAPH__174');">DUAL_GRAPH</a> is a <em class="u">bipartite</em>.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__DUAL_CONNECTED_COMPONENTS__218" onclick="swap_content('span:topaz__DUAL_CONNECTED_COMPONENTS__218'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__DUAL_CONNECTED_COMPONENTS__218" onclick="swap_content('span:topaz__DUAL_CONNECTED_COMPONENTS__218'); return false;"><b>DUAL_CONNECTED_COMPONENTS</b></a>
			()  

			
				→ PowerSet&lt;Int&gt;<div style="display: inline" id="span:topaz__DUAL_CONNECTED_COMPONENTS__218" class="foldit"><br/><div class="descr_func"><div class="descr"><p> The connected components of the <a href="#topaz__DUAL_GRAPH__174" onclick="unfold('span:topaz__DUAL_GRAPH__174');">DUAL_GRAPH</a>, encoded as node sets. </p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__PowerSet__273" onclick="unfold('span:common__PowerSet__273');">PowerSet&lt;Int&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__DUAL_CONNECTIVITY__222" onclick="swap_content('span:topaz__DUAL_CONNECTIVITY__222'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__DUAL_CONNECTIVITY__222" onclick="swap_content('span:topaz__DUAL_CONNECTIVITY__222'); return false;"><b>DUAL_CONNECTIVITY</b></a>
			()  

			
				→ PowerSet&lt;Int&gt;<div style="display: inline" id="span:topaz__DUAL_CONNECTIVITY__222" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Node connectivity of the <a href="#topaz__DUAL_GRAPH__174" onclick="unfold('span:topaz__DUAL_GRAPH__174');">DUAL_GRAPH</a>. Dual to <a href="#topaz__CONNECTIVITY__230" onclick="unfold('span:topaz__CONNECTIVITY__230');">CONNECTIVITY</a>.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__PowerSet__273" onclick="unfold('span:common__PowerSet__273');">PowerSet&lt;Int&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__DUAL_GRAPH_SIGNATURE__223" onclick="swap_content('span:topaz__DUAL_GRAPH_SIGNATURE__223'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__DUAL_GRAPH_SIGNATURE__223" onclick="swap_content('span:topaz__DUAL_GRAPH_SIGNATURE__223'); return false;"><b>DUAL_GRAPH_SIGNATURE</b></a>
			()  

			
				→ Int<div style="display: inline" id="span:topaz__DUAL_GRAPH_SIGNATURE__223" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Difference of the black and white nodes if the <a href="#topaz__DUAL_GRAPH__174" onclick="unfold('span:topaz__DUAL_GRAPH__174');">DUAL_GRAPH</a> is <a href="#topaz__BIPARTITE__221" onclick="unfold('span:topaz__BIPARTITE__221');">BIPARTITE</a>. Otherwise -1. </p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__DUAL_MAX_CLIQUES__220" onclick="swap_content('span:topaz__DUAL_MAX_CLIQUES__220'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__DUAL_MAX_CLIQUES__220" onclick="swap_content('span:topaz__DUAL_MAX_CLIQUES__220'); return false;"><b>DUAL_MAX_CLIQUES</b></a>
			()  

			
				→ PowerSet&lt;Int&gt;<div style="display: inline" id="span:topaz__DUAL_MAX_CLIQUES__220" class="foldit"><br/><div class="descr_func"><div class="descr"><p> The maximal cliques of the <a href="#topaz__DUAL_GRAPH__174" onclick="unfold('span:topaz__DUAL_GRAPH__174');">DUAL_GRAPH</a>, encoded as node sets.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__PowerSet__273" onclick="unfold('span:common__PowerSet__273');">PowerSet&lt;Int&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__GRAPH_SIGNATURE__226" onclick="swap_content('span:topaz__GRAPH_SIGNATURE__226'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__GRAPH_SIGNATURE__226" onclick="swap_content('span:topaz__GRAPH_SIGNATURE__226'); return false;"><b>GRAPH_SIGNATURE</b></a>
			()  

			
				→ Int<div style="display: inline" id="span:topaz__GRAPH_SIGNATURE__226" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Difference of the black and white nodes if the <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a> is <a href="#topaz__BIPARTITE__221" onclick="unfold('span:topaz__BIPARTITE__221');">BIPARTITE</a>. Otherwise -1.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__labeled_vertices__219" onclick="swap_content('span:topaz__labeled_vertices__219'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__labeled_vertices__219" onclick="swap_content('span:topaz__labeled_vertices__219'); return false;"><b>labeled_vertices</b></a>
			(label ...)  

			
				→ Set&lt;Int&gt;<div style="display: inline" id="span:topaz__labeled_vertices__219" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Find the vertices by given labels.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">label ...</td><td><div class="descr"><div>vertex labels</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Set__276" onclick="unfold('span:common__Set__276');">Set&lt;Int&gt;</a></td><td><div class="descr"><div>vertex indices</div></div></td></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__MAX_CLIQUES__228" onclick="swap_content('span:topaz__MAX_CLIQUES__228'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__MAX_CLIQUES__228" onclick="swap_content('span:topaz__MAX_CLIQUES__228'); return false;"><b>MAX_CLIQUES</b></a>
			()  

			
				→ PowerSet&lt;Int&gt;<div style="display: inline" id="span:topaz__MAX_CLIQUES__228" class="foldit"><br/><div class="descr_func"><div class="descr"><p> The maximal cliques of the <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a>, encoded as node sets.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__PowerSet__273" onclick="unfold('span:common__PowerSet__273');">PowerSet&lt;Int&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__VERTEX_DEGREES__227" onclick="swap_content('span:topaz__VERTEX_DEGREES__227'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VERTEX_DEGREES__227" onclick="swap_content('span:topaz__VERTEX_DEGREES__227'); return false;"><b>VERTEX_DEGREES</b></a>
			()  

			
				→ Array&lt;Int&gt;<div style="display: inline" id="span:topaz__VERTEX_DEGREES__227" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Degrees of the vertices in the <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a>.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Topology__132" onclick="swap_content('span:topaz__Topology__132'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Topology__132" onclick="swap_content('span:topaz__Topology__132'); return false;"><span class="category">Topology</span></a></h3></div><div style="display: inline" id="span:topaz__Topology__132" class="foldit"><div class="descr"><p> The following methods compute topological invariants.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__CONNECTED__234" onclick="swap_content('span:topaz__CONNECTED__234'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__CONNECTED__234" onclick="swap_content('span:topaz__CONNECTED__234'); return false;"><b>CONNECTED</b></a>
			()  

			
				→ Bool<div style="display: inline" id="span:topaz__CONNECTED__234" class="foldit"><br/><div class="descr_func"><div class="descr"><p> True if the <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a> is a connected graph.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__DUAL_CONNECTED__232" onclick="swap_content('span:topaz__DUAL_CONNECTED__232'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__DUAL_CONNECTED__232" onclick="swap_content('span:topaz__DUAL_CONNECTED__232'); return false;"><b>DUAL_CONNECTED</b></a>
			()  

			
				→ Bool<div style="display: inline" id="span:topaz__DUAL_CONNECTED__232" class="foldit"><br/><div class="descr_func"><div class="descr"><p> True if the <a href="#topaz__DUAL_GRAPH__174" onclick="unfold('span:topaz__DUAL_GRAPH__174');">DUAL_GRAPH</a> is a connected graph.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__fundamental2gap__233" onclick="swap_content('span:topaz__fundamental2gap__233'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__fundamental2gap__233" onclick="swap_content('span:topaz__fundamental2gap__233'); return false;"><b>fundamental2gap</b></a>
			(filename)  

			
				→ String<div style="display: inline" id="span:topaz__fundamental2gap__233" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Writes the <a href="#topaz__FUNDAMENTAL_GROUP__198" onclick="unfold('span:topaz__FUNDAMENTAL_GROUP__198');">FUNDAMENTAL_GROUP</a> using <a href="#topaz__FUNDAMENTAL_GROUP_GEN_LABELS__199" onclick="unfold('span:topaz__FUNDAMENTAL_GROUP_GEN_LABELS__199');">FUNDAMENTAL_GROUP_GEN_LABELS</a> to
 the given file in <a href="http://polymake.org//external_software#gap" onclick="unfold('span:gap');">GAP</a> input format.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">filename</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__N_CONNECTED_COMPONENTS__231" onclick="swap_content('span:topaz__N_CONNECTED_COMPONENTS__231'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__N_CONNECTED_COMPONENTS__231" onclick="swap_content('span:topaz__N_CONNECTED_COMPONENTS__231'); return false;"><b>N_CONNECTED_COMPONENTS</b></a>
			()  

			
				→ Int<div style="display: inline" id="span:topaz__N_CONNECTED_COMPONENTS__231" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Number of connected components of the <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a>.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Visualization__130" onclick="swap_content('span:topaz__Visualization__130'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Visualization__130" onclick="swap_content('span:topaz__Visualization__130'); return false;"><span class="category">Visualization</span></a></h3></div><div style="display: inline" id="span:topaz__Visualization__130" class="foldit"><div class="descr"><p> These methods are for visualization.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__VISUAL__214" onclick="swap_content('span:topaz__VISUAL__214'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VISUAL__214" onclick="swap_content('span:topaz__VISUAL__214'); return false;"><b>VISUAL</b></a>
			()  

			
				→ Visual::SimplicialComplex<div style="display: inline" id="span:topaz__VISUAL__214" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Visualizes the complex.</p><p> If <a href="#topaz__G_DIM__118" onclick="unfold('span:topaz__G_DIM__118');">G_DIM</a> &lt; 4, the <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a> and the facets
 are visualized using the <a href="#topaz__COORDINATES__117" onclick="unfold('span:topaz__COORDINATES__117');">COORDINATES</a>.</p><p> Otherwise, the spring embedder and the <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a> are used to
 produce coordinates for the visualization.</p><p> If <a href="http://polymake.org//external_software#javaview" onclick="unfold('span:javaview');">JavaView</a> is used to visualize the complex, all faces of
 one facet build a geometry in the jvx-file, so you may use
 <em class="u">Method -&gt; Effect -&gt; Explode Group of Geometries</em> in the JavaView menu.</p></div></div><div class="level3"><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">mixed_graph</td><td><div class="descr"><div>use the <a href="#topaz__MIXED_GRAPH__168" onclick="unfold('span:topaz__MIXED_GRAPH__168');">MIXED_GRAPH</a> for the spring embedder</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">seed</td><td><div class="descr"><div>random seed value for the string embedder</div></div></td></tr><tr><td>option list:</td><td><a href="common.html#common__Visual__Polygon__decorations__341" onclick="unfold('span:common__Visual__Polygon__decorations__341');">Visual::Polygon::decorations</a></td></tr><tr><td>option list:</td><td><a href="graph.html#graph__Visual__Graph__decorations__74" onclick="unfold('span:graph__Visual__Graph__decorations__74');">Visual::Graph::decorations</a></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__Visual__SimplicialComplex__8" onclick="unfold('span:topaz__Visual__SimplicialComplex__8');">Visual::SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__VISUAL_DUAL_GRAPH__213" onclick="swap_content('span:topaz__VISUAL_DUAL_GRAPH__213'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VISUAL_DUAL_GRAPH__213" onclick="swap_content('span:topaz__VISUAL_DUAL_GRAPH__213'); return false;"><b>VISUAL_DUAL_GRAPH</b></a>
			()  

			
				→ Visual::SimplicialComplex<div style="display: inline" id="span:topaz__VISUAL_DUAL_GRAPH__213" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Uses the spring embedder to visualize the <a href="#topaz__DUAL_GRAPH__174" onclick="unfold('span:topaz__DUAL_GRAPH__174');">DUAL_GRAPH</a>.</p></div></div><div class="level3"><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">seed</td><td><div class="descr"><div>random seed value for the string embedder</div></div></td></tr><tr><td>option list:</td><td><a href="graph.html#graph__Visual__Graph__decorations__74" onclick="unfold('span:graph__Visual__Graph__decorations__74');">Visual::Graph::decorations</a></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__Visual__SimplicialComplex__8" onclick="unfold('span:topaz__Visual__SimplicialComplex__8');">Visual::SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__VISUAL_FACE_LATTICE__215" onclick="swap_content('span:topaz__VISUAL_FACE_LATTICE__215'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VISUAL_FACE_LATTICE__215" onclick="swap_content('span:topaz__VISUAL_FACE_LATTICE__215'); return false;"><b>VISUAL_FACE_LATTICE</b></a>
			()  

			
				→ Visual::SimplicialComplexLattice<div style="display: inline" id="span:topaz__VISUAL_FACE_LATTICE__215" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Visualize the <a href="#topaz__HASSE_DIAGRAM__181" onclick="unfold('span:topaz__HASSE_DIAGRAM__181');">HASSE_DIAGRAM</a> of a simplicial complex as a multi-layer graph.</p></div></div><div class="level3"><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">seed</td><td><div class="descr"><div>random seed value for the node placement</div></div></td></tr><tr><td>option list:</td><td><a href="graph.html#graph__Visual__Lattice__decorations__73" onclick="unfold('span:graph__Visual__Lattice__decorations__73');">Visual::Lattice::decorations</a></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__Visual__SimplicialComplexLattice__10" onclick="unfold('span:topaz__Visual__SimplicialComplexLattice__10');">Visual::SimplicialComplexLattice</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__VISUAL_GRAPH__216" onclick="swap_content('span:topaz__VISUAL_GRAPH__216'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VISUAL_GRAPH__216" onclick="swap_content('span:topaz__VISUAL_GRAPH__216'); return false;"><b>VISUAL_GRAPH</b></a>
			()  

			
				→ Visual::SimplicialComplex<div style="display: inline" id="span:topaz__VISUAL_GRAPH__216" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Uses the spring embedder to visualize the <a href="#topaz__GRAPH__185" onclick="unfold('span:topaz__GRAPH__185');">GRAPH</a>.</p></div></div><div class="level3"><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">seed</td><td><div class="descr"><div>random seed value for the string embedder</div></div></td></tr><tr><td>option list:</td><td><a href="graph.html#graph__Visual__Graph__decorations__74" onclick="unfold('span:graph__Visual__Graph__decorations__74');">Visual::Graph::decorations</a></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__Visual__SimplicialComplex__8" onclick="unfold('span:topaz__Visual__SimplicialComplex__8');">Visual::SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__VISUAL_MIXED_GRAPH__217" onclick="swap_content('span:topaz__VISUAL_MIXED_GRAPH__217'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VISUAL_MIXED_GRAPH__217" onclick="swap_content('span:topaz__VISUAL_MIXED_GRAPH__217'); return false;"><b>VISUAL_MIXED_GRAPH</b></a>
			()  

			
				→ Visual::Container<div style="display: inline" id="span:topaz__VISUAL_MIXED_GRAPH__217" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Uses the spring embedder to visualize the <a href="#topaz__MIXED_GRAPH__168" onclick="unfold('span:topaz__MIXED_GRAPH__168');">MIXED_GRAPH</a>.</p></div></div><div class="level3"><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">seed</td><td><div class="descr"><div>random seed value for the string embedder</div></div></td></tr><tr><td>option list:</td><td><a href="graph.html#graph__Visual__Graph__decorations__74" onclick="unfold('span:graph__Visual__Graph__decorations__74');">Visual::Graph::decorations</a></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Visual__Container__337" onclick="unfold('span:common__Visual__Container__337');">Visual::Container</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li></ul><h4>Permutations of SimplicialComplex</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__FacetPerm__134" onclick="swap_content('span:topaz__FacetPerm__134'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__FacetPerm__134" onclick="swap_content('span:topaz__FacetPerm__134'); return false;"><b>FacetPerm</b></a><div style="display: inline" id="span:topaz__FacetPerm__134" class="foldit"><div class="descr"><p> permuting the <a href="#topaz__FACETS__184" onclick="unfold('span:topaz__FACETS__184');">FACETS</a></p></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__VertexPerm__133" onclick="swap_content('span:topaz__VertexPerm__133'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__VertexPerm__133" onclick="swap_content('span:topaz__VertexPerm__133'); return false;"><b>VertexPerm</b></a><div style="display: inline" id="span:topaz__VertexPerm__133" class="foldit"><div class="descr"><p> permuting the vertices</p></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Visual__SimplicialComplex__8" onclick="swap_content('span:topaz__Visual__SimplicialComplex__8'); return false;">
		 	
	</div><div class="unfoldable"><div class="object"><h3><a href="#" class="javalink" id="topaz__Visual__SimplicialComplex__8" onclick="swap_content('span:topaz__Visual__SimplicialComplex__8'); return false;"><span class="object">Visual::SimplicialComplex</span></a></h3></div><div style="display: inline" id="span:topaz__Visual__SimplicialComplex__8" class="foldit"><div class="descr"><p> Visualization of the simplicial complex.</p></div><div class="level3"/><h4>User Methods of Visual::SimplicialComplex</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__FACES__124" onclick="swap_content('span:topaz__FACES__124'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__FACES__124" onclick="swap_content('span:topaz__FACES__124'); return false;"><b>FACES</b></a>
			(PROPERTY_NAME)  

			<div style="display: inline" id="span:topaz__FACES__124" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Add faces with optional different graphical attributes.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">PROPERTY_NAME</td><td><div class="descr"><div>or [ Faces ]</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td>option list:</td><td><a href="common.html#common__Visual__Polygon__decorations__341" onclick="unfold('span:common__Visual__Polygon__decorations__341');">Visual::Polygon::decorations</a></td></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__MORSE_MATCHING__122" onclick="swap_content('span:topaz__MORSE_MATCHING__122'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__MORSE_MATCHING__122" onclick="swap_content('span:topaz__MORSE_MATCHING__122'); return false;"><b>MORSE_MATCHING</b></a>
			()  

			<div style="display: inline" id="span:topaz__MORSE_MATCHING__122" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Add the <a href="#topaz__MATCHING__255" onclick="unfold('span:topaz__MATCHING__255');">MORSE_MATCHING.MATCHING</a> to the visualization of the <a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a>.</p></div></div><div class="level3"><h5>Options</h5><table class="args"><tr><td>option list:</td><td><a href="graph.html#graph__Visual__Graph__decorations__74" onclick="unfold('span:graph__Visual__Graph__decorations__74');">Visual::Graph::decorations</a></td></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__SUBCOMPLEX__123" onclick="swap_content('span:topaz__SUBCOMPLEX__123'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__SUBCOMPLEX__123" onclick="swap_content('span:topaz__SUBCOMPLEX__123'); return false;"><b>SUBCOMPLEX</b></a>
			(PROPERTY_NAME)  

			<div style="display: inline" id="span:topaz__SUBCOMPLEX__123" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Add a subcomplex with optional different graphical attributes.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">PROPERTY_NAME</td><td><div class="descr"><div>or [ Facets ]</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td>option list:</td><td><a href="common.html#common__Visual__Polygon__decorations__341" onclick="unfold('span:common__Visual__Polygon__decorations__341');">Visual::Polygon::decorations</a></td></tr><tr><td>option list:</td><td><a href="graph.html#graph__Visual__Graph__decorations__74" onclick="unfold('span:graph__Visual__Graph__decorations__74');">Visual::Graph::decorations</a></td></tr><tr><td>option list:</td><td><a href="common.html#common__Visual__PointSet__decorations__340" onclick="unfold('span:common__Visual__PointSet__decorations__340');">Visual::PointSet::decorations</a></td></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Visual__SimplicialComplexLattice__10" onclick="swap_content('span:topaz__Visual__SimplicialComplexLattice__10'); return false;">
		 	
	</div><div class="unfoldable"><div class="object"><h3><a href="#" class="javalink" id="topaz__Visual__SimplicialComplexLattice__10" onclick="swap_content('span:topaz__Visual__SimplicialComplexLattice__10'); return false;"><span class="object">Visual::SimplicialComplexLattice</span></a></h3></div><div style="display: inline" id="span:topaz__Visual__SimplicialComplexLattice__10" class="foldit"><div class="descr"><p> Visualization of the <a href="#topaz__HASSE_DIAGRAM__181" onclick="unfold('span:topaz__HASSE_DIAGRAM__181');">HASSE_DIAGRAM</a> of a simplicial complex as a multi-layer graph.</p></div><div class="level3"/><h4>User Methods of Visual::SimplicialComplexLattice</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__FACES__137" onclick="swap_content('span:topaz__FACES__137'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__FACES__137" onclick="swap_content('span:topaz__FACES__137'); return false;"><b>FACES</b></a>
			(faces)  

			
				→ Visual::SimplicialComplexLattice<div style="display: inline" id="span:topaz__FACES__137" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Add distinguished faces with different graphical attributes <em class="param">NodeColor</em> and <em class="param">NodeStyle</em>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Set&gt;</a></td><td class="param">faces</td><td><div class="descr"><div>(to be changed in the near future)</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td>option list:</td><td><a href="graph.html#graph__Visual__Lattice__decorations__73" onclick="unfold('span:graph__Visual__Lattice__decorations__73');">Visual::Lattice::decorations</a></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__Visual__SimplicialComplexLattice__10" onclick="unfold('span:topaz__Visual__SimplicialComplexLattice__10');">Visual::SimplicialComplexLattice</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__MORSE_MATCHING__135" onclick="swap_content('span:topaz__MORSE_MATCHING__135'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__MORSE_MATCHING__135" onclick="swap_content('span:topaz__MORSE_MATCHING__135'); return false;"><b>MORSE_MATCHING</b></a>
			()  

			
				→ Visual::SimplicialComplexLattice<div style="display: inline" id="span:topaz__MORSE_MATCHING__135" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Add the <a href="#topaz__MATCHING__255" onclick="unfold('span:topaz__MATCHING__255');">MORSE_MATCHING.MATCHING</a> to the visualization of the face lattice of the simplicial complex.
 Decoration options @c EdgeColor and @c EdgeStyle apply to the matched edges only.</p></div></div><div class="level3"><h5>Options</h5><table class="args"><tr><td>option list:</td><td><a href="graph.html#graph__Visual__Lattice__decorations__73" onclick="unfold('span:graph__Visual__Lattice__decorations__73');">Visual::Lattice::decorations</a></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__Visual__SimplicialComplexLattice__10" onclick="unfold('span:topaz__Visual__SimplicialComplexLattice__10');">Visual::SimplicialComplexLattice</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__SUBCOMPLEX__136" onclick="swap_content('span:topaz__SUBCOMPLEX__136'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__SUBCOMPLEX__136" onclick="swap_content('span:topaz__SUBCOMPLEX__136'); return false;"><b>SUBCOMPLEX</b></a>
			(property)  

			
				→ Visual::SimplicialComplexLattice<div style="display: inline" id="span:topaz__SUBCOMPLEX__136" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Add a subcomplex with different graphical attributes.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">property</td><td><div class="descr"><div>name of the subcomplex property (to be changed in the near future)</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">show_filter</td><td><div class="descr"><div>containment relationship between the subcomplex and the lattice faces</div></div></td></tr><tr><td>option list:</td><td><a href="graph.html#graph__Visual__Lattice__decorations__73" onclick="unfold('span:graph__Visual__Lattice__decorations__73');">Visual::Lattice::decorations</a></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__Visual__SimplicialComplexLattice__10" onclick="unfold('span:topaz__Visual__SimplicialComplexLattice__10');">Visual::SimplicialComplexLattice</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li></ul></div><div class="level2"><h2>User Functions</h2><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__Combinatorics__17" onclick="swap_content('span:topaz__Combinatorics__17'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Combinatorics__17" onclick="swap_content('span:topaz__Combinatorics__17'); return false;"><span class="category">Combinatorics</span></a></h3></div><div style="display: inline" id="span:topaz__Combinatorics__17" class="foldit"><div class="descr"><p> These functions capture combinatorial information of the object. 
 Combinatorial properties only depend on combinatorial data of the object like, e.g., the face lattice.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__n_poset_homomorphisms__74" onclick="swap_content('span:topaz__n_poset_homomorphisms__74'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__n_poset_homomorphisms__74" onclick="swap_content('span:topaz__n_poset_homomorphisms__74'); return false;"><b>n_poset_homomorphisms</b></a>
			(P, Q)  

			
				→ Int<div style="display: inline" id="span:topaz__n_poset_homomorphisms__74" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Count all order preserving maps from one poset to another.
 They are in fact enumerated, but only the count is kept track of using constant memory.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td class="param">P</td><td/></tr><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td class="param">Q</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">prescribed_map</td><td><div class="descr"><div>A vector of length P.nodes() with those images in Q that should be fixed. Negative entries will be enumerated over.</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Comparing__13" onclick="swap_content('span:topaz__Comparing__13'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Comparing__13" onclick="swap_content('span:topaz__Comparing__13'); return false;"><span class="category">Comparing</span></a></h3></div><div style="display: inline" id="span:topaz__Comparing__13" class="foldit"><div class="descr"><p> These functions compare two <a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__find_facet_vertex_permutations__54" onclick="swap_content('span:topaz__find_facet_vertex_permutations__54'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__find_facet_vertex_permutations__54" onclick="swap_content('span:topaz__find_facet_vertex_permutations__54'); return false;"><b>find_facet_vertex_permutations</b></a>
			(complex1, complex2)  

			
				→ Pair&lt;Array&lt;Int&gt;, Array&lt;int&gt;&gt;<div style="display: inline" id="span:topaz__find_facet_vertex_permutations__54" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Find the permutations of facets and vertices which maps the first complex to the second one.
 The facet permutation is the first component of the return value.
 If the complexes are not isomorphic, an exception is thrown.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex1</td><td/></tr><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex2</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Pair__317" onclick="unfold('span:common__Pair__317');">Pair&lt;Array&lt;Int&gt;, Array&lt;int&gt;&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__isomorphic__55" onclick="swap_content('span:topaz__isomorphic__55'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__isomorphic__55" onclick="swap_content('span:topaz__isomorphic__55'); return false;"><b>isomorphic</b></a>
			(complex1, complex2)  

			
				→ Bool<div style="display: inline" id="span:topaz__isomorphic__55" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Determine whether two given complexes are combinatorially isomorphic.
 The problem is reduced to graph isomorphism of the vertex-facet incidence graphs.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex1</td><td/></tr><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex2</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__pl_homeomorphic__53" onclick="swap_content('span:topaz__pl_homeomorphic__53'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__pl_homeomorphic__53" onclick="swap_content('span:topaz__pl_homeomorphic__53'); return false;"><b>pl_homeomorphic</b></a>
			(complex1, complex2)  

			
				→ Bool<div style="display: inline" id="span:topaz__pl_homeomorphic__53" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Tries to determine whether two complexes are pl-homeomorphic by using
  bistellar flips and a simulated annealing strategy.</p><p> You may specify the maximal number of <em class="param">rounds</em>, how often the system
 may <em class="param">relax</em> before heating up and how much <em class="param">heat</em> should be applied.
 The function stops computing, once the size of the triangulation has not decreased
 for <em class="param">rounds</em> iterations. If the <em class="param">abs</em> flag is set, the function stops
 after <em class="param">rounds</em> iterations regardless of when the last improvement took place.
 Additionally, you may set the threshold <em class="param">min_n_facets</em> for the number of facets when
 the simplification ought to stop. Default is d+2 in the <a href="#topaz__CLOSED_PSEUDO_MANIFOLD__203" onclick="unfold('span:topaz__CLOSED_PSEUDO_MANIFOLD__203');">CLOSED_PSEUDO_MANIFOLD</a> case
 and 1 otherwise.</p><p> If you want to influence the distribution of the dimension of the moves when warming up
 you may do so by specifying a <em class="param">distribution</em>. The number of values in <em class="param">distribution</em>
 determines the dimensions used for heating up. The heating and relaxing parameters decrease dynamically
 unless the <em class="param">constant</em> flag is set. The function prohibits to execute the reversed move of a move
 directly after the move itself unless the <em class="param">allow_rev_move</em> flag is set. Setting the
 <em class="param">allow_rev_move</em> flag might help solve a particular resilient problem.</p><p> If you are interested in how the process is coming along, try the <em class="param">verbose</em> option.
 It specifies after how many rounds the current best result is displayed.</p><p> The <em class="param">obj</em> determines the objective function used for the optimization. If <em class="param">obj</em> is set to 0,
 the function searches for the triangulation with the lexicographically smallest f-vector,
 if <em class="param">obj</em> is set to 1, the function searches for the triangulation with the reversed-lexicographically
 smallest f-vector and if <em class="param">obj</em> is set to 2 the sum of the f-vector entries is used.
 The default is 1.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex1</td><td/></tr><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex2</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">rounds</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">abs</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">obj</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">relax</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">heat</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">constant</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">allow_rev_move</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">min_n_facets</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">verbose</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">seed</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">quiet</td><td/></tr><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">distribution</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Other__12" onclick="swap_content('span:topaz__Other__12'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Other__12" onclick="swap_content('span:topaz__Other__12'); return false;"><span class="category">Other</span></a></h3></div><div style="display: inline" id="span:topaz__Other__12" class="foldit"><div class="descr"><p> Special purpose functions.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__is_generalized_shelling__41" onclick="swap_content('span:topaz__is_generalized_shelling__41'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__is_generalized_shelling__41" onclick="swap_content('span:topaz__is_generalized_shelling__41'); return false;"><b>is_generalized_shelling</b></a>
			(FaceList)  

			
				→ Bool<div style="display: inline" id="span:topaz__is_generalized_shelling__41" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Check if a given sequence of faces of a simplicial complex is a generalized shelling.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Set&gt;</a></td><td class="param">FaceList</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">verbose</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__is_vertex_decomposition__42" onclick="swap_content('span:topaz__is_vertex_decomposition__42'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__is_vertex_decomposition__42" onclick="swap_content('span:topaz__is_vertex_decomposition__42'); return false;"><b>is_vertex_decomposition</b></a>
			(complex, vertices)  

			
				→ Bool<div style="display: inline" id="span:topaz__is_vertex_decomposition__42" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Check whether a given ordered subset of the vertex set is a <em class="u">vertex decomposition</em>.
 Works for 1-, 2- and 3-manifolds only!</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">vertices</td><td><div class="descr"><div>shedding vertices</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">verbose</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__mixed_graph__52" onclick="swap_content('span:topaz__mixed_graph__52'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__mixed_graph__52" onclick="swap_content('span:topaz__mixed_graph__52'); return false;"><b>mixed_graph</b></a>
			(complex)  

			<div style="display: inline" id="span:topaz__mixed_graph__52" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produces the mixed graph of a <em class="param">complex</em>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Float__316" onclick="unfold('span:common__Float__316');">Float</a></td><td class="param">edge_weight</td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__persistent_homology__47" onclick="swap_content('span:topaz__persistent_homology__47'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__persistent_homology__47" onclick="swap_content('span:topaz__persistent_homology__47'); return false;"><b>persistent_homology</b></a>
			&lt;MatrixType&gt;
		 
			(F, i, p, k)  

			
				→ Pair&lt;SparseMatrix&lt;Coeff&gt;, List&lt; Pair&lt;Coeff, SparseMatrix&lt;Coeff&gt; &gt; &gt; &gt;<div style="display: inline" id="span:topaz__persistent_homology__47" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Given a Filtration and three indices i,p and k, this computes the p-persistent k-th homology group of the i-th frame of the filtration for coefficients from any PID. Returns a basis for the free part and a list of torsion coefficients with bases.</p></div></div><div class="level3"><h5>Type Parameters</h5><table class="args"><tr><td class="param">MatrixType</td><td><div class="descr"><div>type of boundary matrices</div></div></td></tr></table><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__Filtration__110" onclick="unfold('span:topaz__Filtration__110');">Filtration&lt;MatrixType&gt;</a></td><td class="param">F</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">i</td><td><div class="descr"><div>the filtration frame</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">p</td><td><div class="descr"><div>the number of frames to consider</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">k</td><td><div class="descr"><div>the dimension in which to compute</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Pair__317" onclick="unfold('span:common__Pair__317');">Pair&lt;SparseMatrix&lt;Coeff&gt;, List&lt; Pair&lt;Coeff, SparseMatrix&lt;Coeff&gt; &gt; &gt; &gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__overload_1__145" onclick="swap_content('span:topaz__overload_1__145'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__overload_1__145" onclick="swap_content('span:topaz__overload_1__145'); return false;"><b>persistent_homology</b></a>
			&lt;MatrixType&gt;
		 
			(F)  

			
				→ Array&lt;List&lt;Pair&lt;int, int&gt; &gt; &gt;<div style="display: inline" id="span:topaz__overload_1__145" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Given a Filtration, this computes its persistence barcodes in all dimension, using the algorithm described in the 2005 paper 'Computing Persistent Homology' by Afra Zomorodian and Gunnar Carlsson. It only works for field coefficients.</p></div></div><div class="level3"><h5>Type Parameters</h5><table class="args"><tr><td class="param">MatrixType</td><td><div class="descr"><div>type of the boundary matrices</div></div></td></tr></table><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__Filtration__110" onclick="unfold('span:topaz__Filtration__110');">Filtration&lt;MatrixType&gt;</a></td><td class="param">F</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;List&lt;Pair&lt;int, int&gt; &gt; &gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__poset_by_inclusion__46" onclick="swap_content('span:topaz__poset_by_inclusion__46'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__poset_by_inclusion__46" onclick="swap_content('span:topaz__poset_by_inclusion__46'); return false;"><b>poset_by_inclusion</b></a>
			(P)  

			
				→ Graph&lt;Directed&gt;<div style="display: inline" id="span:topaz__poset_by_inclusion__46" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Construct the inclusion poset from a given container.
 The elements of the container are interpreted as sets.  They define a poset
 by inclusion.  The function returns this poset encoded as a directed graph.
 The direction is towards to larger sets.  All relations are encoded, not
 only the covering relations.
 For details see Assarf, Joswig &amp; Pfeifle:
 Webs of stars or how to triangulate sums of polytopes, to appear</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;T&gt;</a></td><td class="param">P</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__random_discrete_morse__48" onclick="swap_content('span:topaz__random_discrete_morse__48'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__random_discrete_morse__48" onclick="swap_content('span:topaz__random_discrete_morse__48'); return false;"><b>random_discrete_morse</b></a>
			(complex)  

			
				→ Map&lt; Array&lt;Int&gt;, Int &gt;<div style="display: inline" id="span:topaz__random_discrete_morse__48" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Implementation of random discrete Morse algorithms by Lutz and Benedetti
 Returns a map of the number of occurrences of different reduction results indexed by the corresponding discrete Morse vectors (containing the number of critical cells per dimension)</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">rounds</td><td><div class="descr"><div>Run for <em class="param">r</em> rounds</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">seed</td><td><div class="descr"><div>Set seed number for random number generator</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">strategy</td><td><div class="descr"><div>Set <em class="param">strategy</em>=&gt;0 (default) for random-random: uniformly random selecting of a face to collapse or as critical face
               Set <em class="param">strategy</em>=&gt;1 for random-lex-first: uniformly random relabeling of vertices, then selecting lexicographically first face for collapse or as a critical face
               Set <em class="param">strategy</em>=&gt;2 for random-lex-last: uniformly random relabeling of vertices, then selecting lexicographically last face for collapse or as a critical face</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">verbose</td><td><div class="descr"><div><em class="param">v</em> Prints message after running every <em class="param">v</em> rounds</div></div></td></tr><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">try_until_reached</td><td><div class="descr"><div>Used together with <em class="param">rounds</em>=&gt;r; When <em class="param">try_until_reached</em>=&gt;[a,...,b], runs for <em class="param">r</em> rounds or until [a,...,b] is found</div></div></td></tr><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">try_until_exception</td><td><div class="descr"><div>Used together with <em class="param">rounds</em>=&gt;r; When <em class="param">try_until_exception</em>=&gt;[a,...,b], runs for <em class="param">r</em> rounds or until anything other than [a,...,b] is found</div></div></td></tr><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">save_collapsed</td><td><div class="descr"><div>Save all facets that remain after initial collapse to an XML file of a Simplicial Complex. Rounds that have Morse vector [1,0,...,0] or [1,0,...,0,1] will save nothing. Filename must have quotation marks: <em class="param">save_collapsed</em>=&gt;"path/to/filename". The XML files are saved as "path/to/filename_currentround.top".</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Map__279" onclick="unfold('span:common__Map__279');">Map&lt; Array&lt;Int&gt;, Int &gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__stabbing_order__43" onclick="swap_content('span:topaz__stabbing_order__43'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__stabbing_order__43" onclick="swap_content('span:topaz__stabbing_order__43'); return false;"><b>stabbing_order</b></a>
			(P)  

			
				→ graph::Graph&lt;Directed&gt;<div style="display: inline" id="span:topaz__stabbing_order__43" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Determine the stabbing partial order of a simplicial ball with respect to the origin.
 The origin may be a vertex or not.
 For details see Assarf, Joswig &amp; Pfeifle:
 Webs of stars or how to triangulate sums of polytopes, to appear</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td class="param">P</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">graph::Graph&lt;Directed&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__stanley_reisner__49" onclick="swap_content('span:topaz__stanley_reisner__49'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__stanley_reisner__49" onclick="swap_content('span:topaz__stanley_reisner__49'); return false;"><b>stanley_reisner</b></a>
			(complex)  

			
				→ ideal::Ideal<div style="display: inline" id="span:topaz__stanley_reisner__49" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Creates the <em class="u">Stanley-Reisner ideal</em> of a simplicial complex.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="ideal.html#ideal__Ideal__6" onclick="unfold('span:ideal__Ideal__6');">ideal::Ideal</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__star_of_zero__44" onclick="swap_content('span:topaz__star_of_zero__44'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__star_of_zero__44" onclick="swap_content('span:topaz__star_of_zero__44'); return false;"><b>star_of_zero</b></a>
			(C)  

			
				→ Set&lt;Set&lt;Int&gt;&gt;<div style="display: inline" id="span:topaz__star_of_zero__44" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Find the facets of the star of the origin in the simplicial complex.
 The origin may be a vertex or not.
 For details see Assarf, Joswig &amp; Pfeifle:
 Webs of stars or how to triangulate sums of polytopes, to appear</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td class="param">C</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Set__276" onclick="unfold('span:common__Set__276');">Set&lt;Set&lt;Int&gt;&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__star_shaped_balls__50" onclick="swap_content('span:topaz__star_shaped_balls__50'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__star_shaped_balls__50" onclick="swap_content('span:topaz__star_shaped_balls__50'); return false;"><b>star_shaped_balls</b></a>
			(P)  

			
				→ Array&lt;Set&lt;Set&gt;&gt;<div style="display: inline" id="span:topaz__star_shaped_balls__50" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Enumerate all balls formed by the simplices of a geometric simplicial complex
 that are strictly star-shaped with respect to the origin.
 The origin may be a vertex or not.
 For details see Assarf, Joswig &amp; Pfeifle:
 Webs of stars or how to triangulate sums of polytopes, to appear</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td class="param">P</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Set&lt;Set&gt;&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__stiefel_whitney__51" onclick="swap_content('span:topaz__stiefel_whitney__51'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__stiefel_whitney__51" onclick="swap_content('span:topaz__stiefel_whitney__51'); return false;"><b>stiefel_whitney</b></a>
			(facets)  

			
				→ Array&lt;PowerSet&lt;Int&gt;&gt;<div style="display: inline" id="span:topaz__stiefel_whitney__51" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes <em class="u">Stiefel-Whitney classes</em> of mod 2 Euler space (in particular, closed manifold).
 Use option <em class="param">verbose</em> to show regular pairs and cycles.
 A narrower dimension range of interest can be specified.
 Negative values are treated as co-dimension - 1</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Set&lt;Int&gt;&gt;</a></td><td class="param">facets</td><td><div class="descr"><div>the facets of the simplicial complex</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="#" onclick="unfold('span:');">Int</a></td><td class="param">high_dim</td><td/></tr><tr><td><a href="#" onclick="unfold('span:');">Int</a></td><td class="param">low_dim</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">verbose</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;PowerSet&lt;Int&gt;&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__vietoris_rips_filtration__45" onclick="swap_content('span:topaz__vietoris_rips_filtration__45'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__vietoris_rips_filtration__45" onclick="swap_content('span:topaz__vietoris_rips_filtration__45'); return false;"><b>vietoris_rips_filtration</b></a>
			&lt;Coeff&gt;
		 
			(D, deg, step_size, k)  

			
				→ Filtration&lt;SparseMatrix&lt;Coeff, NonSymmetric&gt; &gt;<div style="display: inline" id="span:topaz__vietoris_rips_filtration__45" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Constructs the k-skeleton of the Vietrois Rips filtration of a point set. The set is passed as its so-called "distance matrix", whose (i,j)-entry is the distance between point i and j. This matrix can e.g. be computed using the distance_matrix function. The other inputs are an integer array containing the degree of each point, the desired distance step size between frames, and the dimension up to which to compute the skeleton. Redundant points will appear as seperate vertices of the complex. Setting k to |S| will compute the entire VR-Complex for each frame.</p></div></div><div class="level3"><h5>Type Parameters</h5><table class="args"><tr><td class="param">Coeff</td><td><div class="descr"><div>desired coefficient type of the filtration</div></div></td></tr></table><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Matrix__300" onclick="unfold('span:common__Matrix__300');">Matrix</a></td><td class="param">D</td><td><div class="descr"><div>the "distance matrix" of the point set (can be upper triangular)</div></div></td></tr><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">deg</td><td><div class="descr"><div>the degrees of input points</div></div></td></tr><tr><td><a href="common.html#common__Float__316" onclick="unfold('span:common__Float__316');">Float</a></td><td class="param">step_size</td><td/></tr><tr><td><a href="#" onclick="unfold('span:');">Int</a></td><td class="param">k</td><td><div class="descr"><div>dimension of the resulting filtration</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__Filtration__110" onclick="unfold('span:topaz__Filtration__110');">Filtration&lt;SparseMatrix&lt;Coeff, NonSymmetric&gt; &gt;</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Producing_a_new_simplicial_complex_from_others__19" onclick="swap_content('span:topaz__Producing_a_new_simplicial_complex_from_others__19'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Producing_a_new_simplicial_complex_from_others__19" onclick="swap_content('span:topaz__Producing_a_new_simplicial_complex_from_others__19'); return false;"><span class="category">Producing a new simplicial complex from others</span></a></h3></div><div style="display: inline" id="span:topaz__Producing_a_new_simplicial_complex_from_others__19" class="foldit"><div class="descr"><p> These functions construct a new <a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a> from other objects of the same type.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__alexander_dual__84" onclick="swap_content('span:topaz__alexander_dual__84'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__alexander_dual__84" onclick="swap_content('span:topaz__alexander_dual__84'); return false;"><b>alexander_dual</b></a>
			(complex)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__alexander_dual__84" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes the Alexander dual complex, that is, the complements of all non-faces.
 The vertex labels are preserved unless the <em class="param">no_labels</em> flag is specified.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__barycentric_subdivision__88" onclick="swap_content('span:topaz__barycentric_subdivision__88'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__barycentric_subdivision__88" onclick="swap_content('span:topaz__barycentric_subdivision__88'); return false;"><b>barycentric_subdivision</b></a>
			(complex)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__barycentric_subdivision__88" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes the <em class="u">barycentric subdivision</em> of <em class="param">complex</em>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">pin_hasse_section</td><td><div class="descr"><div>default: HASSE_DIAGRAM</div></div></td></tr><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">label_section</td><td><div class="descr"><div>default: VERTEX_LABELS</div></div></td></tr><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">coord_section</td><td><div class="descr"><div>default: VERTICES</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">geometric_realization</td><td><div class="descr"><div>set to 1 to obtain a <a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a>, default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td><div class="descr"><div>(or <a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a>)</div></div></td></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">To subdivide a triangle into six new triangles, do this:<code>&gt; $b = barycentric_subdivision(simplex(2));</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__bistellar_simplification__89" onclick="swap_content('span:topaz__bistellar_simplification__89'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__bistellar_simplification__89" onclick="swap_content('span:topaz__bistellar_simplification__89'); return false;"><b>bistellar_simplification</b></a>
			(complex)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__bistellar_simplification__89" class="foldit"><br/><div class="descr_func"><div class="descr"><p>  Heuristic for simplifying the triangulation of the given manifold
  without changing its PL-type. The function uses
  bistellar flips and a simulated annealing strategy.</p><p> You may specify the maximal number of <em class="param">rounds</em>, how often the system
 may <em class="param">relax</em> before heating up and how much <em class="param">heat</em> should be applied.
 The function stops computing, once the size of the triangulation has not decreased
 for <em class="param">rounds</em> iterations. If the <em class="param">abs</em> flag is set, the function stops
 after <em class="param">rounds</em> iterations regardless of when the last improvement took place.
 Additionally, you may set the threshold <em class="param">min_n_facets</em> for the number of facets when
 the simplification ought to stop. Default is d+2 in the <a href="#topaz__CLOSED_PSEUDO_MANIFOLD__203" onclick="unfold('span:topaz__CLOSED_PSEUDO_MANIFOLD__203');">CLOSED_PSEUDO_MANIFOLD</a> case
 and 1 otherwise.</p><p> If you want to influence the distribution of the dimension of the moves when warming up
 you may do so by specifying a <em class="param">distribution</em>. The number of values in <em class="param">distribution</em>
 determines the dimensions used for heating up. The heating and relaxing parameters decrease dynamically
 unless the <em class="param">constant</em> flag is set. The function prohibits to execute the reversed move of a move
 directly after the move itself unless the <em class="param">allow_rev_move</em> flag is set. Setting the
 <em class="param">allow_rev_move</em> flag might help solve a particular resilient problem.</p><p> If you are interested in how the process is coming along, try the <em class="param">verbose</em> option.
 It specifies after how many rounds the current best result is displayed.</p><p> The <em class="param">obj</em> determines the objective function used for the optimization. If <em class="param">obj</em> is set to 0,
 the function searches for the triangulation with the lexicographically smallest f-vector,
 if <em class="param">obj</em> is set to any other value the sum of the f-vector entries is used.
 The default is 1.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">rounds</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">abs</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">obj</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">relax</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">heat</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">constant</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">allow_rev_move</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">min_n_facets</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">verbose</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">seed</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">quiet</td><td/></tr><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">distribution</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__bs2quotient__93" onclick="swap_content('span:topaz__bs2quotient__93'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__bs2quotient__93" onclick="swap_content('span:topaz__bs2quotient__93'); return false;"><b>bs2quotient</b></a>
			(P, complex)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__bs2quotient__93" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Create a simplicial complex from a simplicial subdivision of a given complex
 by identifying vertices on the boundary of the original complex according to a group that acts on vertices.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="polytope.html#polytope__Polytope__20" onclick="unfold('span:polytope__Polytope__20');">polytope::Polytope</a></td><td class="param">P</td><td><div class="descr"><div>the underlying polytope</div></div></td></tr><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td><div class="descr"><div>a sufficiently fine subdivision of P, for example the second barycentric subdivision</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__cone__81" onclick="swap_content('span:topaz__cone__81'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__cone__81" onclick="swap_content('span:topaz__cone__81'); return false;"><b>cone</b></a>
			(complex, k)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__cone__81" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce the <em class="param">k</em>-cone over a given simplicial complex.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">k</td><td><div class="descr"><div>default is 1</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;String&gt;</a></td><td class="param">apex_labels</td><td><div class="descr"><div>labels of the apex vertices.
  Default labels have the form <code>apex_0, apex_1, ...</code>.
  In the case the input complex has already vertex labels of this kind,
  the duplicates are avoided.</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">The following creates the cone with two apices over the triangle,
 with custom apex labels. The resulting complex is the 4-simplex.<code>&gt; $c = cone(simplex(2),2,apex_labels=&gt;['foo','bar']);</code><code>&gt; print $c-&gt;FACETS;</code><code> {0 1 2 3 4}</code><code>&gt; print $c-&gt;VERTEX_LABELS;</code><code> 0 1 2 foo bar</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__connected_sum__80" onclick="swap_content('span:topaz__connected_sum__80'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__connected_sum__80" onclick="swap_content('span:topaz__connected_sum__80'); return false;"><b>connected_sum</b></a>
			(complex1, complex2, f1, f2)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__connected_sum__80" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Compute the <em class="u">connected sum</em> of two complexes.</p><p> Parameters <em class="param">f_1 and </em>f_2// specify which facet of the first and second complex correspondingly are glued together.
 Default is the 0-th facet of both.</p><p> The vertices in the selected facets are identified with each other according to their order in the facet
 (that is, in icreasing index order). The glueing facet iteself is not included in the connected sum.
  The option <em class="param">permutation</em> allows to get an alternative identification. It should specify a
 permutation of the vertices of the second facet.</p><p> The vertices of the new complex get the original labels with <code>_1</code> or <code>_2</code> appended, according to the input complex
  they came from.  If you set the <em class="param">no_labels</em> flag, the label generation will be omitted.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex1</td><td/></tr><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex2</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">f1</td><td><div class="descr"><div>default: 0</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">f2</td><td><div class="descr"><div>default: 0</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">permutation</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">Glueing together two tori to make a genus 2 double torus, rotating the second one clockwise:<code>&gt; $cs = connected_sum(torus(),torus(),permutation=&gt;[1,2,0]);</code><code>&gt; print $cs-&gt;SURFACE.','.$cs-&gt;GENUS;</code><code> 1,2</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__covering_relations__100" onclick="swap_content('span:topaz__covering_relations__100'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__covering_relations__100" onclick="swap_content('span:topaz__covering_relations__100'); return false;"><b>covering_relations</b></a>
			(P)  

			
				→ Graph&lt;Directed&gt;<div style="display: inline" id="span:topaz__covering_relations__100" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Construct the covering relations of a poset</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td class="param">P</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__deletion__94" onclick="swap_content('span:topaz__deletion__94'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__deletion__94" onclick="swap_content('span:topaz__deletion__94'); return false;"><b>deletion</b></a>
			(complex, face)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__deletion__94" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Remove the given <em class="param">face</em> and all the faces containing it.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Set__276" onclick="unfold('span:common__Set__276');">Set&lt;Int&gt;</a></td><td class="param">face</td><td><div class="descr"><div>specified by vertex indices.
  Please use <a href="#topaz__labeled_vertices__219" onclick="unfold('span:topaz__labeled_vertices__219');">labeled_vertices</a> if you want to specify the face by vertex labels.</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__disjoint_union__98" onclick="swap_content('span:topaz__disjoint_union__98'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__disjoint_union__98" onclick="swap_content('span:topaz__disjoint_union__98'); return false;"><b>disjoint_union</b></a>
			(complex1, complex2)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__disjoint_union__98" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce the <em class="u">disjoint union</em> of the two given complexes.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex1</td><td/></tr><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex2</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0
 The vertex labels are built from the original labels with a suffix <code>_1</code> or <code>_2</code> appended.</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__edge_contraction__82" onclick="swap_content('span:topaz__edge_contraction__82'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__edge_contraction__82" onclick="swap_content('span:topaz__edge_contraction__82'); return false;"><b>edge_contraction</b></a>
			(complex)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__edge_contraction__82" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Heuristic for simplifying the triangulation of the given manifold
 without changing its PL-type. Choosing a random order of the vertices,
 the function tries to contract all incident edges.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">seed</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__foldable_prism__83" onclick="swap_content('span:topaz__foldable_prism__83'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__foldable_prism__83" onclick="swap_content('span:topaz__foldable_prism__83'); return false;"><b>foldable_prism</b></a>
			(complex)  

			
				→ GeometricSimplicialComplex<div style="display: inline" id="span:topaz__foldable_prism__83" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce a <em class="u">prism</em> over a given <a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td class="param">complex</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">geometric_realization</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__hom_poset__90" onclick="swap_content('span:topaz__hom_poset__90'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__hom_poset__90" onclick="swap_content('span:topaz__hom_poset__90'); return false;"><b>hom_poset</b></a>
			(P, Q)  

			
				→ Graph&lt;Directed&gt;<div style="display: inline" id="span:topaz__hom_poset__90" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Construct the poset of order preserving maps from one poset to another</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td class="param">P</td><td/></tr><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td class="param">Q</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__overload_1__157" onclick="swap_content('span:topaz__overload_1__157'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__overload_1__157" onclick="swap_content('span:topaz__overload_1__157'); return false;"><b>hom_poset</b></a>
			(homs, Q)  

			
				→ Graph&lt;Directed&gt;<div style="display: inline" id="span:topaz__overload_1__157" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Construct the poset of order preserving maps from one poset to another</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Array&lt;Int&gt;&gt;</a></td><td class="param">homs</td><td/></tr><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td class="param">Q</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__h_induced_quotient__103" onclick="swap_content('span:topaz__h_induced_quotient__103'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__h_induced_quotient__103" onclick="swap_content('span:topaz__h_induced_quotient__103'); return false;"><b>h_induced_quotient</b></a>
			(C, vertices)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__h_induced_quotient__103" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Let <em class="param">C</em> be the given simplicial and A the subcomplex induced by
 the given <em class="param">vertices</em>. Then this function produces a simplicial complex
 homotopy equivalent to <em class="param">C</em> mod A by adding the cone over A with
 apex a to <em class="param">C</em>.
 The label of the apex my be specified via the option <em class="param">apex</em>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">C</td><td/></tr><tr><td><a href="common.html#common__Set__276" onclick="unfold('span:common__Set__276');">Set&lt;Int&gt;</a></td><td class="param">vertices</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">apex</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__induced_subcomplex__101" onclick="swap_content('span:topaz__induced_subcomplex__101'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__induced_subcomplex__101" onclick="swap_content('span:topaz__induced_subcomplex__101'); return false;"><b>induced_subcomplex</b></a>
			(complex, vertices)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__induced_subcomplex__101" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce the subcomplex consisting of all faces which are contained in the given set of <em class="param">vertices</em>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Set__276" onclick="unfold('span:common__Set__276');">Set&lt;Int&gt;</a></td><td class="param">vertices</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">geom_real</td><td><div class="descr"><div>tells the client to inherit the <a href="#topaz__COORDINATES__117" onclick="unfold('span:topaz__COORDINATES__117');">COORDINATES</a>.</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__iterated_barycentric_subdivision__96" onclick="swap_content('span:topaz__iterated_barycentric_subdivision__96'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__iterated_barycentric_subdivision__96" onclick="swap_content('span:topaz__iterated_barycentric_subdivision__96'); return false;"><b>iterated_barycentric_subdivision</b></a>
			(complex, k)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__iterated_barycentric_subdivision__96" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes the <em class="param">k</em>-th <em class="u">barycentric subdivision</em> of <em class="param">complex</em> by iteratively calling <a href="#topaz__barycentric_subdivision__88" onclick="unfold('span:topaz__barycentric_subdivision__88');">barycentric_subdivision</a>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">k</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">pin_hasse_section</td><td><div class="descr"><div>default: HASSE_DIAGRAM</div></div></td></tr><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">label_section</td><td><div class="descr"><div>default: VERTEX_LABELS</div></div></td></tr><tr><td><a href="common.html#common__String__323" onclick="unfold('span:common__String__323');">String</a></td><td class="param">coord_section</td><td><div class="descr"><div>default: VERTICES</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">geometric_realization</td><td><div class="descr"><div>set to 1 to obtain a <a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a>, default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td><div class="descr"><div>(or <a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a>)</div></div></td></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__join_complexes__102" onclick="swap_content('span:topaz__join_complexes__102'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__join_complexes__102" onclick="swap_content('span:topaz__join_complexes__102'); return false;"><b>join_complexes</b></a>
			(complex1, complex2)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__join_complexes__102" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Creates the join of <em class="param">complex1</em> and <em class="param">complex2</em>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex1</td><td/></tr><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex2</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0
  The vertex labels are built from the original labels with a suffix <code>_1</code> or <code>_2</code> appended.</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__k_skeleton__79" onclick="swap_content('span:topaz__k_skeleton__79'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__k_skeleton__79" onclick="swap_content('span:topaz__k_skeleton__79'); return false;"><b>k_skeleton</b></a>
			(complex, k)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__k_skeleton__79" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce the <em class="param">k</em>-skeleton.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">k</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__overload_1__153" onclick="swap_content('span:topaz__overload_1__153'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__overload_1__153" onclick="swap_content('span:topaz__overload_1__153'); return false;"><b>k_skeleton</b></a>
			(complex, k)  

			
				→ GeometricSimplicialComplex<div style="display: inline" id="span:topaz__overload_1__153" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce the <em class="param">k</em>-skeleton.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">k</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__link_complex__91" onclick="swap_content('span:topaz__link_complex__91'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__link_complex__91" onclick="swap_content('span:topaz__link_complex__91'); return false;"><b>link_complex</b></a>
			(complex, face)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__link_complex__91" class="foldit"><br/><div class="descr_func"><div class="descr"><p>  Produce the <em class="u">link</em> of a <em class="param">face</em> of the <em class="param">complex</em></p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Set__276" onclick="unfold('span:common__Set__276');">Set&lt;int&gt;</a></td><td class="param">face</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__poset_homomorphisms__85" onclick="swap_content('span:topaz__poset_homomorphisms__85'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__poset_homomorphisms__85" onclick="swap_content('span:topaz__poset_homomorphisms__85'); return false;"><b>poset_homomorphisms</b></a>
			(P, Q)  

			
				→ Array&lt;Array&lt;Int&gt;&gt;<div style="display: inline" id="span:topaz__poset_homomorphisms__85" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Enumerate all order preserving maps from one poset to another</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td class="param">P</td><td/></tr><tr><td><a href="graph.html#graph__Graph_Directed__139" onclick="unfold('span:graph__Graph_Directed__139');">Graph&lt;Directed&gt;</a></td><td class="param">Q</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">prescribed_map</td><td><div class="descr"><div>A vector of length P.nodes() with those images in Q that should be fixed. Negative entries will be enumerated over.</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Array&lt;Int&gt;&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__simplicial_product__87" onclick="swap_content('span:topaz__simplicial_product__87'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__simplicial_product__87" onclick="swap_content('span:topaz__simplicial_product__87'); return false;"><b>simplicial_product</b></a>
			(complex1, complex2)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__simplicial_product__87" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes the <em class="u">simplicial product</em> of two complexes.
 Vertex orderings may be given as options.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex1</td><td/></tr><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex2</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">vertex_order1</td><td/></tr><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">vertex_order2</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">geometric_realization</td><td><div class="descr"><div>default 0</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">color_cons</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__overload_1__155" onclick="swap_content('span:topaz__overload_1__155'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__overload_1__155" onclick="swap_content('span:topaz__overload_1__155'); return false;"><b>simplicial_product</b></a>
			&lt;Scalar&gt;
		 
			(complex1, complex2)  

			
				→ GeometricSimplicialComplex&lt;Scalar&gt;<div style="display: inline" id="span:topaz__overload_1__155" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes the <em class="u">simplicial product</em> of two complexes.
 Vertex orderings may be given as options.</p></div></div><div class="level3"><h5>Type Parameters</h5><table class="args"><tr><td class="param">Scalar</td><td/></tr></table><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td class="param">complex1</td><td/></tr><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td class="param">complex2</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">vertex_order1</td><td/></tr><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">vertex_order2</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">geometric_realization</td><td><div class="descr"><div>default 1</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">color_cons</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex&lt;Scalar&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__star__99" onclick="swap_content('span:topaz__star__99'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__star__99" onclick="swap_content('span:topaz__star__99'); return false;"><b>star</b></a>
			(complex, face)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__star__99" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce the <em class="u">star</em> of the <em class="param">face</em> of the <em class="param">complex</em>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Set__276" onclick="unfold('span:common__Set__276');">Set&lt;int&gt;</a></td><td class="param">face</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__star_deletion__95" onclick="swap_content('span:topaz__star_deletion__95'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__star_deletion__95" onclick="swap_content('span:topaz__star_deletion__95'); return false;"><b>star_deletion</b></a>
			(complex, face)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__star_deletion__95" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Remove the star of a given <em class="param">face</em>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Set__276" onclick="unfold('span:common__Set__276');">Set&lt;Int&gt;</a></td><td class="param">face</td><td><div class="descr"><div>specified by vertex indices.
  Please use <a href="#topaz__labeled_vertices__219" onclick="unfold('span:topaz__labeled_vertices__219');">labeled_vertices</a> if you want to specify the face by vertex labels.</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__stellar_subdivision__97" onclick="swap_content('span:topaz__stellar_subdivision__97'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__stellar_subdivision__97" onclick="swap_content('span:topaz__stellar_subdivision__97'); return false;"><b>stellar_subdivision</b></a>
			(complex, faces)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__stellar_subdivision__97" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes the complex obtained by stellar subdivision of the given <em class="param">faces</em> of the <em class="param">complex</em>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Set&lt;Int&gt;&gt;</a></td><td class="param">faces</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">geometric_realization</td><td><div class="descr"><div>default 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__overload_1__159" onclick="swap_content('span:topaz__overload_1__159'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__overload_1__159" onclick="swap_content('span:topaz__overload_1__159'); return false;"><b>stellar_subdivision</b></a>
			(complex, face)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__overload_1__159" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes the complex obtained by stellar subdivision of the given <em class="param">face</em> of the <em class="param">complex</em>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Set__276" onclick="unfold('span:common__Set__276');">Set&lt;Int&gt;</a></td><td class="param">face</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">geometric_realization</td><td><div class="descr"><div>default 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__sum_triangulation__78" onclick="swap_content('span:topaz__sum_triangulation__78'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__sum_triangulation__78" onclick="swap_content('span:topaz__sum_triangulation__78'); return false;"><b>sum_triangulation</b></a>
			(P, Q, WebOfStars)  

			
				→ GeometricSimplicialComplex<div style="display: inline" id="span:topaz__sum_triangulation__78" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce a specific sum-triangulation of two given triangulations.
 and a WebOfStars.  There are P-sum-triangulations and Q-sum-triangulations.
 If the image of the star of the origin of P is empty then we have a
 Q-sum-triangulation; otherwise it is a P-sum-triangulation.
 For details see Assarf, Joswig &amp; Pfeifle:
 Webs of stars or how to triangulate sums of polytopes, to appear</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td class="param">P</td><td><div class="descr"><div>first complex</div></div></td></tr><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td class="param">Q</td><td><div class="descr"><div>second complex</div></div></td></tr><tr><td><a href="common.html#common__IncidenceMatrix__280" onclick="unfold('span:common__IncidenceMatrix__280');">IncidenceMatrix</a></td><td class="param">WebOfStars</td><td><div class="descr"><div>Every row corresponds to a full dimensional simplex in P and every column to a full dimensional simplex in Q.</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">origin_first</td><td><div class="descr"><div>decides if the origin should be the first point in the resulting complex. Default=0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__suspension__92" onclick="swap_content('span:topaz__suspension__92'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__suspension__92" onclick="swap_content('span:topaz__suspension__92'); return false;"><b>suspension</b></a>
			(complex, k)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__suspension__92" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce the <em class="u"><em class="param">k</em>-suspension</em> over a given simplicial complex.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">k</td><td><div class="descr"><div>default value is 1</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;String&gt;</a></td><td class="param">labels</td><td><div class="descr"><div>for the apices.
  By default apices are labeled with <code>apex_0+</code>, <code>apex_0-</code>, <code>apex_1+</code>, etc.
  If one of the specified labels already exists, a unique one is made
  by appending <code>_i</code> where <em class="param">i</em> is some small number.</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__union__86" onclick="swap_content('span:topaz__union__86'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__union__86" onclick="swap_content('span:topaz__union__86'); return false;"><b>union</b></a>
			(complex1, complex2)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__union__86" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce the union of the two given complexes, identifying
 vertices with equal labels.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex1</td><td/></tr><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">complex2</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__web_of_stars__104" onclick="swap_content('span:topaz__web_of_stars__104'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__web_of_stars__104" onclick="swap_content('span:topaz__web_of_stars__104'); return false;"><b>web_of_stars</b></a>
			(poset_hom, star_shaped_balls, triang)  

			
				→ IncidenceMatrix<div style="display: inline" id="span:topaz__web_of_stars__104" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce a web of stars from two given triangulations
 and a map between them.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td class="param">poset_hom</td><td><div class="descr"><div>the poset homomorphism from stabbing order to star-shaped balls</div></div></td></tr><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Set&lt;Set&lt;Int&gt;&gt;&gt;</a></td><td class="param">star_shaped_balls</td><td><div class="descr"><div>the collection of star-shaped balls of T</div></div></td></tr><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Set&lt;Int&gt;&gt;</a></td><td class="param">triang</td><td><div class="descr"><div>the facets of the underlying triangulation of Q</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__IncidenceMatrix__280" onclick="unfold('span:common__IncidenceMatrix__280');">IncidenceMatrix</a></td><td><div class="descr"><div>WebOfStars Every row corresponds to a full dimensional simplex in P and every column to a full dimensional simplex in Q.</div></div></td></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Producing_a_simplicial_complex_from_other_objects__18" onclick="swap_content('span:topaz__Producing_a_simplicial_complex_from_other_objects__18'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Producing_a_simplicial_complex_from_other_objects__18" onclick="swap_content('span:topaz__Producing_a_simplicial_complex_from_other_objects__18'); return false;"><span class="category">Producing a simplicial complex from other objects</span></a></h3></div><div style="display: inline" id="span:topaz__Producing_a_simplicial_complex_from_other_objects__18" class="foldit"><div class="descr"><p> These functions construct a new <a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a> from other objects.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__clique_complex__75" onclick="swap_content('span:topaz__clique_complex__75'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__clique_complex__75" onclick="swap_content('span:topaz__clique_complex__75'); return false;"><b>clique_complex</b></a>
			(graph)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__clique_complex__75" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce the <em class="u">clique complex</em> of a given graph, that is, the simplicial
 complex that has an n-dimensional facet for each n+1-clique.
 If <em class="param">no_labels</em> is set to 1, the labels are not copied.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="graph.html#graph__Graph__77" onclick="unfold('span:graph__Graph__77');">Graph</a></td><td class="param">graph</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">Create the clique complex of a simple graph with one 3-clique and
  one 2-clique, not creating labels.<code>&gt; $g = graph_from_edges([[0,1],[0,2],[1,2],[2,3]]);</code><code>&gt; $c = clique_complex($g,no_labels=&gt;1);</code><code>&gt; print $c-&gt;FACETS;</code><code> {0 1 2}</code><code> {2 3}</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__independence_complex__77" onclick="swap_content('span:topaz__independence_complex__77'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__independence_complex__77" onclick="swap_content('span:topaz__independence_complex__77'); return false;"><b>independence_complex</b></a>
			(matroid)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__independence_complex__77" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce the <em class="u">independence complex</em> of a given matroid.
 If <em class="param">no_labels</em> is set to 1, the labels are not copied.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="matroid.html#matroid__Matroid__6" onclick="unfold('span:matroid__Matroid__6');">matroid::Matroid</a></td><td class="param">matroid</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_labels</td><td><div class="descr"><div>Do not create <a href="#topaz__VERTEX_LABELS__169" onclick="unfold('span:topaz__VERTEX_LABELS__169');">VERTEX_LABELS</a>. default: 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__vietoris_rips_complex__76" onclick="swap_content('span:topaz__vietoris_rips_complex__76'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__vietoris_rips_complex__76" onclick="swap_content('span:topaz__vietoris_rips_complex__76'); return false;"><b>vietoris_rips_complex</b></a>
			(D, delta)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__vietoris_rips_complex__76" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes the <em class="u">Vietoris Rips complex</em> of a point set. The set is passed as its so-called "distance matrix", whose (i,j)-entry is the distance between point i and j. This matrix can e.g. be computed using the distance_matrix function. The points corresponding to vertices of a common simplex will all have a distance less than <em class="param">delta</em> from each other.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Matrix__300" onclick="unfold('span:common__Matrix__300');">Matrix</a></td><td class="param">D</td><td><div class="descr"><div>the "distance matrix" of the point set (can be upper triangular)</div></div></td></tr><tr><td><a href="common.html#common__Rational__328" onclick="unfold('span:common__Rational__328');">Rational</a></td><td class="param">delta</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Producing_from_scratch__14" onclick="swap_content('span:topaz__Producing_from_scratch__14'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Producing_from_scratch__14" onclick="swap_content('span:topaz__Producing_from_scratch__14'); return false;"><span class="category">Producing from scratch</span></a></h3></div><div style="display: inline" id="span:topaz__Producing_from_scratch__14" class="foldit"><div class="descr"><p> With these clients you can create special examples of simplicial complexes and complexes belonging to parameterized families.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__ball__64" onclick="swap_content('span:topaz__ball__64'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__ball__64" onclick="swap_content('span:topaz__ball__64'); return false;"><b>ball</b></a>
			(d)  

			
				→ GeometricSimplicialComplex<div style="display: inline" id="span:topaz__ball__64" class="foldit"><br/><div class="descr_func"><div class="descr"><p> A <em class="param">d</em>-dimensional <em class="u">ball</em>, realized as the <em class="param">d</em>-simplex.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">d</td><td><div class="descr"><div>dimension</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td/></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">The following produces the 3-ball and stores it in the variable $b:<code>&gt; $b = ball(3);</code> You can print the facets of the resulting simplicial complex like so:<code>&gt; print $b-&gt;FACETS;</code><code> {0 1 2 3}</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__complex_projective_plane__65" onclick="swap_content('span:topaz__complex_projective_plane__65'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__complex_projective_plane__65" onclick="swap_content('span:topaz__complex_projective_plane__65'); return false;"><b>complex_projective_plane</b></a>
			()  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__complex_projective_plane__65" class="foldit"><br/><div class="descr_func"><div class="descr"><p> The complex projective plane with the vertex-minimal triangulation by Kühnel and Brehm.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">Construct the complex projective plane, store it in the variable $p2c, and print its homology group.<code>&gt; $p2c = complex_projective_plane();</code><code>&gt; print $p2c-&gt;HOMOLOGY;</code><code> ({} 0)</code><code> ({} 0)</code><code> ({} 1)</code><code> ({} 0)</code><code> ({} 1)</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__cube_complex__67" onclick="swap_content('span:topaz__cube_complex__67'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__cube_complex__67" onclick="swap_content('span:topaz__cube_complex__67'); return false;"><b>cube_complex</b></a>
			(x_1)  

			
				→ GeometricSimplicialComplex&lt;Rational&gt;<div style="display: inline" id="span:topaz__cube_complex__67" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produces a triangulated pile of hypercubes, arranged in a d-dimensional array.
 Each cube is split into d! tetrahedra, and the tetrahedra are all grouped around
 one of the diagonal axes of the cube.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">x_1</td><td><div class="descr"><div><em class="u">,...,x_d</em> specifying the shape of the pile:
 d is the dimension of the cubes to be stacked, and the stack will be
 x_1 by x_2 by ... by x_d cubes.</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex&lt;Rational&gt;</a></td><td/></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">Arrange four triangulated 3-cubes to form a big 2 by 2 cube:<code>&gt; $cc = cube_complex(2,2,2);</code><code>&gt; print $cc-&gt;description;</code><code> 2x2x2 Pile of 3-dimensional triangulated cubes.</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__klein_bottle__63" onclick="swap_content('span:topaz__klein_bottle__63'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__klein_bottle__63" onclick="swap_content('span:topaz__klein_bottle__63'); return false;"><b>klein_bottle</b></a>
			()  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__klein_bottle__63" class="foldit"><br/><div class="descr_func"><div class="descr"><p> The Klein bottle.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__multi_associahedron_sphere__58" onclick="swap_content('span:topaz__multi_associahedron_sphere__58'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__multi_associahedron_sphere__58" onclick="swap_content('span:topaz__multi_associahedron_sphere__58'); return false;"><b>multi_associahedron_sphere</b></a>
			(n, k)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__multi_associahedron_sphere__58" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce the simplicial sphere //Δ(n,k)<em class="param"> of (</em>k<em class="param">+1)-crossing free multitriangulations
 of an </em>n<em class="param">-gon </em>P<em class="param">, along with the group action on the diagonals induced from </em>D<em class="param">_{2</em>n<em class="param">}.
 </em>Δ(n,k)<em class="param"> is the simplicial complex on the set of relevant diagonals of </em>P<em class="param"> whose faces are those sets
 of diagonals such that no </em>k<em class="param">+1 of them mutually cross. A diagonal is </em>relevant<em class="param"> if it leaves
 </em>k<em class="param"> or more vertices of </em>P<em class="param"> on both sides. (Any diagonal having less than </em>k<em class="param"> vertices on one
 side trivially cannot participate in a (</em>k<em class="param">+1)-crossing, so is </em>irrelevant<em class="param">. The corresponding
 complex on </em>all// diagonals is therefore the simplicial join of this one with the simplex of irrelevant
 diagonals.)
</p><blockquote><div> Jakob Jonsson, "Generalized triangulations and diagonal-free subsets of stack polyominoes",</div><div> J. Combin. Theory Ser. A, 112(1):117–142, 2005</div></blockquote><p> <em class="param">Delta(n,k)</em> is known to be a <em class="param">k</em>-neighborly vertex-decomposable sphere of dimension <em class="param">k</em>ν-1,
 where the parameter ν=<em class="param">n</em>-2<em class="param">k</em>-1 measures the complexity of this construction.
 For ν=0, the complex is a point; for ν=1 a <em class="param">k</em>-simplex; for ν=2 the boundary of a cyclic polytope.
 Setting <em class="param">k</em>=1 yields the boundary of the simplicial associahedron.
 The list of (<em class="param">k</em>+1)-crossings in the <em class="param">n</em>-gon is included as the attachment K_PLUS_1_CROSSINGS. It can
 also be obtained as the property MINIMAL_NON_FACES, but this requires the HASSE_DIAGRAM to be computed.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">n</td><td><div class="descr"><div>the number of vertices of the polygon</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">k</td><td><div class="descr"><div>the number of diagonals that are allowed to mutually cross</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_facets</td><td><div class="descr"><div>don't calculate the facets (for large examples)? Default 0</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">no_crossings</td><td><div class="descr"><div>don't calculate the crossings? Default 0</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div><br/><div class="examples"><b>Examples:</b><ul><li><div class="descr">The f-vector of Δ(9,3) is that of a neighborly polytope, since ν=2:<code>&gt; print multi_associahedron_sphere(9,3)-&gt;F_VECTOR;</code><code> 9 36 84 117 90 30</code></div></li><li><div class="descr">The option no_facets=&gt;1 still leaves useful information:<code>&gt; $s = multi_associahedron_sphere(8,2, no_facets=&gt;1);</code><code>&gt; print $s-&gt;VERTEX_LABELS;</code><code> (0 3) (1 4) (2 5) (3 6) (4 7) (0 5) (1 6) (2 7) (0 4) (1 5) (2 6) (3 7)</code><code>&gt; print $s-&gt;GROUP-&gt;PERMUTATION_ACTION-&gt;GENERATORS;</code><code> 7 0 1 2 3 4 5 6 11 8 9 10</code><code> 4 3 2 1 0 7 6 5 11 10 9 8</code><code>&gt; print $s-&gt;get_attachment("K_PLUS_1_CROSSINGS")-&gt;size();</code><code> 28</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__rand_knot__66" onclick="swap_content('span:topaz__rand_knot__66'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__rand_knot__66" onclick="swap_content('span:topaz__rand_knot__66'); return false;"><b>rand_knot</b></a>
			(n_edges)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__rand_knot__66" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce a random knot (or link) as a polygonal closed curve in 3-space.
 The knot (or each connected component of the link) has <em class="param">n_edges</em> edges.</p><p> The vertices are uniformly distributed in [-1,1]<sup>3</sup>, unless the <em class="param">on_sphere</em> option is set.
 In the latter case the vertices are uniformly distributed on the 3-sphere. Alternatively
 the <em class="param">brownian</em> option produces a knot by connecting the ends of a simulated brownian motion.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">n_edges</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">n_comp</td><td><div class="descr"><div>number of components, default is 1.</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">on_sphere</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">brownian</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">seed</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__real_projective_plane__60" onclick="swap_content('span:topaz__real_projective_plane__60'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__real_projective_plane__60" onclick="swap_content('span:topaz__real_projective_plane__60'); return false;"><b>real_projective_plane</b></a>
			()  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__real_projective_plane__60" class="foldit"><br/><div class="descr_func"><div class="descr"><p> The real projective plane with its unique minimal triangulation on six vertices.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__simplex__61" onclick="swap_content('span:topaz__simplex__61'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__simplex__61" onclick="swap_content('span:topaz__simplex__61'); return false;"><b>simplex</b></a>
			(d)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__simplex__61" class="foldit"><br/><div class="descr_func"><div class="descr"><p> A <em class="u">simplex</em> of dimension <em class="param">d</em>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">d</td><td><div class="descr"><div>dimension</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__sphere__57" onclick="swap_content('span:topaz__sphere__57'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__sphere__57" onclick="swap_content('span:topaz__sphere__57'); return false;"><b>sphere</b></a>
			(d)  

			
				→ GeometricSimplicialComplex<div style="display: inline" id="span:topaz__sphere__57" class="foldit"><br/><div class="descr_func"><div class="descr"><p> The <em class="param">d</em>-dimensional <em class="u">sphere</em>, realized as the boundary of the (<em class="param">d</em>+1)-simplex.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">d</td><td><div class="descr"><div>dimension</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__surface__62" onclick="swap_content('span:topaz__surface__62'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__surface__62" onclick="swap_content('span:topaz__surface__62'); return false;"><b>surface</b></a>
			(g)  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__surface__62" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produce a <em class="u">surface of genus <em class="param">g</em></em>. For <em class="param">g</em> &gt;= 0
 the client produces an orientable surface, otherwise
 it produces a non-orientable one.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">g</td><td><div class="descr"><div>genus</div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__torus__56" onclick="swap_content('span:topaz__torus__56'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__torus__56" onclick="swap_content('span:topaz__torus__56'); return false;"><b>torus</b></a>
			()  

			
				→ SimplicialComplex<div style="display: inline" id="span:topaz__torus__56" class="foldit"><br/><div class="descr_func"><div class="descr"><p> The Császár Torus. Geometric realization by Frank Lutz,
 Electronic Geometry Model No. 2001.02.069</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__unknot__59" onclick="swap_content('span:topaz__unknot__59'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__unknot__59" onclick="swap_content('span:topaz__unknot__59'); return false;"><b>unknot</b></a>
			(m, n)  

			
				→ GeometricSimplicialComplex<div style="display: inline" id="span:topaz__unknot__59" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Produces a triangulated 3-sphere with the particularly NASTY embedding
 of the unknot in its 1-skeleton. The parameters <em class="param">m</em> &gt;= 2 and <em class="param">n</em> &gt;= 1
 determine how entangled the unknot is. <em class="param">eps</em> determines the <a href="#topaz__COORDINATES__117" onclick="unfold('span:topaz__COORDINATES__117');">COORDINATES</a>.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">m</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">n</td><td/></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Rational__328" onclick="unfold('span:common__Rational__328');">Rational</a></td><td class="param">eps</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#topaz__GeometricSimplicialComplex__6" onclick="unfold('span:topaz__GeometricSimplicialComplex__6');">GeometricSimplicialComplex</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Producing_other_objects__15" onclick="swap_content('span:topaz__Producing_other_objects__15'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Producing_other_objects__15" onclick="swap_content('span:topaz__Producing_other_objects__15'); return false;"><span class="category">Producing other objects</span></a></h3></div><div style="display: inline" id="span:topaz__Producing_other_objects__15" class="foldit"><div class="descr"><p> Functions producing big objects which are not contained in application topaz.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__DCEL_secondary_fan_input__68" onclick="swap_content('span:topaz__DCEL_secondary_fan_input__68'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__DCEL_secondary_fan_input__68" onclick="swap_content('span:topaz__DCEL_secondary_fan_input__68'); return false;"><b>DCEL_secondary_fan_input</b></a>
			()  

			<div style="display: inline" id="span:topaz__DCEL_secondary_fan_input__68" class="foldit"><br/><div class="descr_func"><div class="descr"><p> some strange function</p></div></div><div class="level3"/></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__secondary_polyhedron__69" onclick="swap_content('span:topaz__secondary_polyhedron__69'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__secondary_polyhedron__69" onclick="swap_content('span:topaz__secondary_polyhedron__69'); return false;"><b>secondary_polyhedron</b></a>
			(s, depth)  

			
				→ polytope::Polytope&lt;Float&gt;<div style="display: inline" id="span:topaz__secondary_polyhedron__69" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Computes the secondary polyhedron of a hyperbolic surface up to a given depth
 of the spanning tree of the covering triangluation of the hypoerbolic plane.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__HyperbolicSurface__11" onclick="unfold('span:topaz__HyperbolicSurface__11');">HyperbolicSurface</a></td><td class="param">s</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">depth</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="polytope.html#polytope__Polytope_Float__398" onclick="unfold('span:polytope__Polytope_Float__398');">polytope::Polytope&lt;Float&gt;</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Topology__16" onclick="swap_content('span:topaz__Topology__16'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Topology__16" onclick="swap_content('span:topaz__Topology__16'); return false;"><span class="category">Topology</span></a></h3></div><div style="display: inline" id="span:topaz__Topology__16" class="foldit"><div class="descr"><p> The following functions compute topological invariants.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__betti_numbers__72" onclick="swap_content('span:topaz__betti_numbers__72'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__betti_numbers__72" onclick="swap_content('span:topaz__betti_numbers__72'); return false;"><b>betti_numbers</b></a>
			&lt;Coeff&gt;
		 
			(C)  

			
				→ Array&lt;Int&gt;<div style="display: inline" id="span:topaz__betti_numbers__72" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Calculate the betti numbers of a general chain complex over a field.</p></div></div><div class="level3"><h5>Type Parameters</h5><table class="args"><tr><td class="param">Coeff</td><td><div class="descr"><div>The coefficient field type for homology computation. Defaults to Rational</div></div></td></tr></table><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__ChainComplex__112" onclick="unfold('span:topaz__ChainComplex__112');">ChainComplex</a></td><td class="param">C</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td><div class="descr"><div>containing the i-th  betti number at entry i</div></div></td></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">The following constructs a simple chain complex with only one non-empty differential:<code>&gt; $cc = new ChainComplex(new Array&lt;SparseMatrix&lt;Integer&gt;&gt;([[[2,0]]]));</code> You can print its betti numbers like this:<code>&gt; print betti_numbers($cc);</code><code> 1 0</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__overload_1__149" onclick="swap_content('span:topaz__overload_1__149'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__overload_1__149" onclick="swap_content('span:topaz__overload_1__149'); return false;"><b>betti_numbers</b></a>
			&lt;Coeff&gt;
		 
			(S)  

			
				→ Array&lt;Int&gt;<div style="display: inline" id="span:topaz__overload_1__149" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Calculate the reduced betti numbers of a simplicial complex over a field.</p></div></div><div class="level3"><h5>Type Parameters</h5><table class="args"><tr><td class="param">Coeff</td><td><div class="descr"><div>The coefficient field type for homology computation. Defaults to Rational</div></div></td></tr></table><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__SimplicialComplex__9" onclick="unfold('span:topaz__SimplicialComplex__9');">SimplicialComplex</a></td><td class="param">S</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Int&gt;</a></td><td><div class="descr"><div>containing the i-th  betti number at entry i</div></div></td></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">To print the betti numbers for the torus, do this:<code>&gt; $t = torus();</code><code>&gt; print betti_numbers($t);</code><code> 0 2 1</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__cap_product__71" onclick="swap_content('span:topaz__cap_product__71'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__cap_product__71" onclick="swap_content('span:topaz__cap_product__71'); return false;"><b>cap_product</b></a>
			(cocycles, cycles)  

			
				→ Pair&lt;CycleGroup&lt;E&gt;,Map&lt;Pair&lt;Int,Int&gt;,Int&gt;&gt;<div style="display: inline" id="span:topaz__cap_product__71" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Compute all cap products of cohomology and homology cycles in two given groups.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__CycleGroup__111" onclick="unfold('span:topaz__CycleGroup__111');">CycleGroup&lt;E&gt;</a></td><td class="param">cocycles</td><td/></tr><tr><td><a href="#topaz__CycleGroup__111" onclick="unfold('span:topaz__CycleGroup__111');">CycleGroup&lt;E&gt;</a></td><td class="param">cycles</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Pair__317" onclick="unfold('span:common__Pair__317');">Pair&lt;CycleGroup&lt;E&gt;,Map&lt;Pair&lt;Int,Int&gt;,Int&gt;&gt;</a></td><td/></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">The following stores all cap products of the cocycles and cycles
  of the homology group of the oriented surface of genus 1 in the variable $cp.<code>&gt; $s = surface(1);</code><code>&gt; $cp = cap_product($s-&gt;COCYCLES-&gt;[1],$s-&gt;CYCLES-&gt;[1]);</code></div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__homology__73" onclick="swap_content('span:topaz__homology__73'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__homology__73" onclick="swap_content('span:topaz__homology__73'); return false;"><b>homology</b></a>
			(complex, co)  

			<div style="display: inline" id="span:topaz__homology__73" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Calculate the reduced <em class="u">(co-)homology groups</em> of a simplicial complex.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Set&lt;int&gt;&gt;</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">co</td><td><div class="descr"><div>set to true for <em class="u">co</em>homology</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">dim_low</td><td><div class="descr"><div>narrows the dimension range of interest, with negative values being treated as co-dimensions</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">dim_high</td><td><div class="descr"><div>see <em class="param">dim_low</em></div></div></td></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__overload_1__150" onclick="swap_content('span:topaz__overload_1__150'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__overload_1__150" onclick="swap_content('span:topaz__overload_1__150'); return false;"><b>homology</b></a>
			(CC, co)  

			
				→ Array&lt;HomologyGroup&lt;Integer&gt;&gt;<div style="display: inline" id="span:topaz__overload_1__150" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Calculate the <em class="u">(co-)homology groups</em> of a chain complex.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__ChainComplex__112" onclick="unfold('span:topaz__ChainComplex__112');">ChainComplex</a></td><td class="param">CC</td><td><div class="descr"><div>The chain complex for which to compute homology.</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">co</td><td><div class="descr"><div>set to true for <em class="u">co</em>homology</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">dim_low</td><td><div class="descr"><div>narrows the dimension range of interest, with negative values being treated as co-dimensions</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">dim_high</td><td><div class="descr"><div>see <em class="param">dim_low</em></div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;HomologyGroup&lt;Integer&gt;&gt;</a></td><td/></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">To construct a small chain complex with only one non-zero differential:<code>&gt; $cc = new ChainComplex(new Array&lt;SparseMatrix&lt;Integer&gt;&gt;([[[2,0]]]));</code> This prints its homology groups.<code>&gt; print homology($cc,0);</code><code> ({(2 1)} 1)</code><code> ({} 0)</code> The output means that the zeroth homology group has 2-torsion with multiplicity one, and betti number one.
 The first homology group is empty.</div></li></ul></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__homology_and_cycles__70" onclick="swap_content('span:topaz__homology_and_cycles__70'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__homology_and_cycles__70" onclick="swap_content('span:topaz__homology_and_cycles__70'); return false;"><b>homology_and_cycles</b></a>
			(complex, co)  

			<div style="display: inline" id="span:topaz__homology_and_cycles__70" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Calculate the reduced <em class="u">(co-)homology groups</em> and <em class="u">cycle representatives</em> of a simplicial complex.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Set&lt;int&gt;&gt;</a></td><td class="param">complex</td><td/></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">co</td><td><div class="descr"><div>set to true for <em class="u">co</em>homology</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">dim_low</td><td><div class="descr"><div>narrows the dimension range of interest, with negative values being treated as co-dimensions</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">dim_high</td><td><div class="descr"><div>see <em class="param">dim_low</em></div></div></td></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__overload_1__146" onclick="swap_content('span:topaz__overload_1__146'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__overload_1__146" onclick="swap_content('span:topaz__overload_1__146'); return false;"><b>homology_and_cycles</b></a>
			(CC, co)  

			
				→ Array&lt;Pair&lt;HomologyGroup, SparseMatrix&gt;&gt;<div style="display: inline" id="span:topaz__overload_1__146" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Calculate the <em class="u">(co-)homology groups</em> and __cycle coefficient matrices_ of a chain complex.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="#topaz__ChainComplex__112" onclick="unfold('span:topaz__ChainComplex__112');">ChainComplex&lt;SparseMatrix&lt;Integer&gt;&gt;</a></td><td class="param">CC</td><td><div class="descr"><div>The chain complex for which to compute homology.</div></div></td></tr><tr><td><a href="common.html#common__Bool__327" onclick="unfold('span:common__Bool__327');">Bool</a></td><td class="param">co</td><td><div class="descr"><div>set to true for <em class="u">co</em>homology</div></div></td></tr></table><h5>Options</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">dim_low</td><td><div class="descr"><div>narrows the dimension range of interest, with negative values being treated as co-dimensions</div></div></td></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">dim_high</td><td><div class="descr"><div>see <em class="param">dim_low</em></div></div></td></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Pair&lt;HomologyGroup, SparseMatrix&gt;&gt;</a></td><td><div class="descr"><div>For each dimension, contains the homology group and corresponding
  cycle group coefficient matrix where each row of the matrix represents a generator, column indices referring to indices
  of the chain group elements involved.</div></div></td></tr></table></div><br/><div class="examples"><b>Example:</b><ul style="list-style-type:none"><li><div class="descr">To construct a small chain complex with only one non-zero differential:<code>&gt; $cc = new ChainComplex(new Array&lt;SparseMatrix&lt;Integer&gt;&gt;([[[2,0]]]));</code> This prints its homology groups and corresponding generators.<code>&gt; print homology_and_cycles($cc,0);</code><code> (({(2 1)} 1)</code><code> &lt;1 0</code><code> 0 1</code><code> &gt;</code><code> )</code><code> (({} 0)</code><code> &lt;&gt;</code><code> )</code> The output means that the zeroth homology group has 2-torsion with multiplicity one generated by the first elemen
 of the chain group, and free part of rank one generated by the second element. The first homology group is empty.</div></li></ul></div></div></div></div></li></ul></div></div></div></li></ul></div><div class="level3"><h2>Property Types</h2><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__Topology__30" onclick="swap_content('span:topaz__Topology__30'); return false;">
		 	
	</div><div class="unfoldable"><div class="category"><h3><a href="#" class="javalink" id="topaz__Topology__30" onclick="swap_content('span:topaz__Topology__30'); return false;"><span class="category">Topology</span></a></h3></div><div style="display: inline" id="span:topaz__Topology__30" class="foldit"><div class="descr"><p> The following property_types are topological invariants.</p></div><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__Cell__109" onclick="swap_content('span:topaz__Cell__109'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__Cell__109" onclick="swap_content('span:topaz__Cell__109'); return false;"><b>Cell</b></a><div style="display: inline" id="span:topaz__Cell__109" class="foldit"><div class="undoc">UNDOCUMENTED</div><div class="level3"/></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__ChainComplex__112" onclick="swap_content('span:topaz__ChainComplex__112'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__ChainComplex__112" onclick="swap_content('span:topaz__ChainComplex__112'); return false;"><b>ChainComplex</b></a>
			&lt;MatrixType&gt;
		<div style="display: inline" id="span:topaz__ChainComplex__112" class="foldit"><div class="descr"><p> A finite chain complex, represented as its boundary matrices.
 Check out the tutorial on the polymake homepage for examples on constructing ChainComplexes and computing their homology.</p></div><div class="level3"><h5>Type Parameters</h5><table class="args"><tr><td class="param">MatrixType</td><td><div class="descr"><div>The type of the differential matrices. default: SparseMatrix&lt;Integer&gt;</div></div></td></tr></table></div><h4>User Methods of ChainComplex</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__boundary_matrix__242" onclick="swap_content('span:topaz__boundary_matrix__242'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__boundary_matrix__242" onclick="swap_content('span:topaz__boundary_matrix__242'); return false;"><b>boundary_matrix</b></a>
			(d)  

			
				→ MatrixType<div style="display: inline" id="span:topaz__boundary_matrix__242" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Returns the d-boundary matrix of the chain complex.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">d</td><td/></tr></table><h5>Returns</h5><table class="args"><tr><td><a href="#" onclick="unfold('span:');">MatrixType</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__dim__243" onclick="swap_content('span:topaz__dim__243'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__dim__243" onclick="swap_content('span:topaz__dim__243'); return false;"><b>dim</b></a>
			()  

			
				→ Int<div style="display: inline" id="span:topaz__dim__243" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Returns the number of non-empty modules in the complex.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__CycleGroup__111" onclick="swap_content('span:topaz__CycleGroup__111'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__CycleGroup__111" onclick="swap_content('span:topaz__CycleGroup__111'); return false;"><b>CycleGroup</b></a>
			&lt;Scalar&gt;
		<div style="display: inline" id="span:topaz__CycleGroup__111" class="foldit"><div class="descr"><p> A group is encoded as a pair of an integer matrix and a vector of faces.
 The elements of the group can be obtained by symbolic multiplication of both.</p><p> Access methods: <em class="param">coeff</em> delivers the integer matrix, <em class="param">faces</em> the vector of faces.</p></div><div class="level3"><h5>Type Parameters</h5><table class="args"><tr><td class="param">Scalar</td><td><div class="descr"><div>integer type of matrix elements</div></div></td></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__Filtration__110" onclick="swap_content('span:topaz__Filtration__110'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__Filtration__110" onclick="swap_content('span:topaz__Filtration__110'); return false;"><b>Filtration</b></a>
			&lt;MatrixType&gt;
		<div style="display: inline" id="span:topaz__Filtration__110" class="foldit"><div class="descr"><p> A filtration of chain complexes.</p></div><div class="level3"><h5>Type Parameters</h5><table class="args"><tr><td class="param">MatrixType</td><td/></tr></table></div><h4>User Methods of Filtration</h4><ul class="unfoldable"><li><div class="li"><div class="icon" id="icon:topaz__boundary_matrix__241" onclick="swap_content('span:topaz__boundary_matrix__241'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__boundary_matrix__241" onclick="swap_content('span:topaz__boundary_matrix__241'); return false;"><b>boundary_matrix</b></a>
			(d, t)  

			<div style="display: inline" id="span:topaz__boundary_matrix__241" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Returns the d-boundary matrix of the t-th frame of the filtration.</p></div></div><div class="level3"><h5>Parameters</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">d</td><td/></tr><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td class="param">t</td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__cells__239" onclick="swap_content('span:topaz__cells__239'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__cells__239" onclick="swap_content('span:topaz__cells__239'); return false;"><b>cells</b></a>
			()  

			
				→ Array&lt;Cell&gt;<div style="display: inline" id="span:topaz__cells__239" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Returns the cells of the filtration, given as array of 3-tuples containing degree, dimension and
 boundary matrix row number of the cell.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Array__319" onclick="unfold('span:common__Array__319');">Array&lt;Cell&gt;</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__dim__238" onclick="swap_content('span:topaz__dim__238'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__dim__238" onclick="swap_content('span:topaz__dim__238'); return false;"><b>dim</b></a>
			()  

			
				→ Int<div style="display: inline" id="span:topaz__dim__238" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Returns the dimension of the maximal cells in the last frame of the filtration.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__n_cells__237" onclick="swap_content('span:topaz__n_cells__237'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__n_cells__237" onclick="swap_content('span:topaz__n_cells__237'); return false;"><b>n_cells</b></a>
			()  

			
				→ Int<div style="display: inline" id="span:topaz__n_cells__237" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Returns the number of cells in the last frame of the filtration.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td/></tr></table></div></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__n_frames__240" onclick="swap_content('span:topaz__n_frames__240'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__n_frames__240" onclick="swap_content('span:topaz__n_frames__240'); return false;"><b>n_frames</b></a>
			()  

			
				→ Int<div style="display: inline" id="span:topaz__n_frames__240" class="foldit"><br/><div class="descr_func"><div class="descr"><p> Returns the number of frames in of the filtration.</p></div></div><div class="level3"><h5>Returns</h5><table class="args"><tr><td><a href="common.html#common__Int__318" onclick="unfold('span:common__Int__318');">Int</a></td><td/></tr></table></div></div></div></div></li></ul></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__HomologyGroup__108" onclick="swap_content('span:topaz__HomologyGroup__108'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__HomologyGroup__108" onclick="swap_content('span:topaz__HomologyGroup__108'); return false;"><b>HomologyGroup</b></a><div style="display: inline" id="span:topaz__HomologyGroup__108" class="foldit"><div class="descr"><p> A group is encoded as a sequence ( { (t<sub>1</sub> m<sub>1</sub>) ...  (t<sub>n</sub>  m<sub>n</sub>) } f) of non-negative integers,
 with t<sub>1</sub> &gt; t<sub>2</sub> &gt; ... &gt; t<sub>n</sub> &gt; 1, plus an extra non-negative integer f.</p><p> The group is isomorphic to (Z/t<sub>1</sub>)<sup>m<sub>1</sub></sup> × ... × (Z/t<sub>n</sub>)<sup>m<sub>n</sub></sup> × Z<sup>f</sup>, 
 where Z<sup>0</sup> is the trivial group.</p><p> Access methods: <em class="param">torsion</em> delivers the list of Z-groups, <em class="param">betti_number</em> the number f.</p></div><div class="level3"/></div></div></div></li><li><div class="li"><div class="icon" id="icon:topaz__IntersectionForm__113" onclick="swap_content('span:topaz__IntersectionForm__113'); return false;">
		 	
	</div><div class="unfoldable"><a href="#" class="javalink" id="topaz__IntersectionForm__113" onclick="swap_content('span:topaz__IntersectionForm__113'); return false;"><b>IntersectionForm</b></a><div style="display: inline" id="span:topaz__IntersectionForm__113" class="foldit"><div class="descr"><p> Parity and signature of the intersection form of a closed oriented 4k-manifold.
 See <a href="#topaz__INTERSECTION_FORM__206" onclick="unfold('span:topaz__INTERSECTION_FORM__206');">INTERSECTION_FORM</a>.</p></div><div class="level3"/></div></div></div></li></ul></div></div></div></li></ul></div></div>
